#!/bin/bash


. /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

CUR_DIR="`pwd`"
INSTALL_DIR=${CUR_DIR}/install

CORES=$((2*$(cat /proc/cpuinfo | grep -c processor)))
#CORES=1

check_status()
{
	if [ "$?" != "0" ]; then
		echo "**** Build fails!"
		exit 1
	fi
}

#make menuconfig
#exit

cp defconfig_ht8xx .config

if [ -n "$(grep "CONFIG_LOAD_LIB_DYNAMIC_SUPPORT=y" .config)" ];then
    export CONFIG_LOAD_LIB_DYNAMIC_SUPPORT=y
fi
NVRAM_INCLUDE="${CUR_DIR}/../../../../ht/system/nvtool/"
OPENSSL_INCLUDE="${CUR_DIR}/../openssl-1.0.2j/include/"
GS_LIB_DIR="${CUR_DIR}/../../../../ht/image_build/image_source/base/usr/lib/:${CUR_DIR}/../../../../ht/image_build/image_source/base/lib/"
export C_INCLUDE_PATH=${NVRAM_INCLUDE}:${OPENSSL_INCLUDE}:${C_INCLUDE_PATH}
export LIBRARY_PATH=${GS_LIB_DIR}:${LIBRARY_PATH}

make clean
make -j${CORES}
check_status

cp busybox ../../../../ht/image_build/image_source/base/bin/busybox.nosuid

#make PREFIX=${INSTALL_DIR} install CROSS_COMPILE=arm-dspg-linux-uclibceabi-

