/* vi: set sw=4 ts=4: */
/*
 * Licensed under GPLv2, see file LICENSE in this source tree.
 */
#ifndef UDHCP_DHCPC_H
#define UDHCP_DHCPC_H 1

PUSH_AND_SET_FUNCTION_VISIBILITY_TO_HIDDEN

/*Information for option 125*/
struct device_info {
	char opt_code ;
	unsigned char opt_len ;
	uint32_t pen ;
	unsigned char data_len ;
	char *ManufacturerOUI ;
	unsigned char oui_len ;
	char SerialNumber[128] ;
	unsigned char sn_len ;
	char *ProductClass ;
	unsigned char pc_len ;
	char *string ;
};

/* Information for option 124 */
#define VERDOR_CLASS_DATA_NUM 1

typedef struct _vendor_class_data
{
	uint32_t enterprise_number;
	uint8_t data_len;
	char* class_data;

}vendor_class_data, *pvendor_class_data;

typedef struct _vendor_class_opt
{
	uint8_t option_code;
	uint8_t option_len;
	vendor_class_data data[VERDOR_CLASS_DATA_NUM];
	char * option_buffer;
	uint8_t enable;

}vendor_class_opt, *pvendor_class_opt;

struct client_config_t {
	uint8_t client_mac[6];          /* Our mac address */
	IF_FEATURE_UDHCP_PORT(uint16_t port;)
	int ifindex;                    /* Index number of the interface to use */
	uint8_t opt_mask[256 / 8];      /* Bitmask of options to send (-O option) */
	const char *interface;          /* The name of the interface to use */
	char *pidfile;                  /* Optionally store the process ID */
	const char *script;             /* User script to run at dhcp events */
	struct option_set *options;     /* list of DHCP options to send to server */
	uint8_t *clientid;              /* Optional client id to use */
	uint8_t *vendorclass;           /* Optional vendor class-id to use */
	uint8_t *hostname;              /* Optional hostname to use */
	uint8_t *domainname;
	uint8_t *fqdn;                  /* Optional fully qualified domain name to use */

	uint16_t first_secs;
	uint16_t last_secs;

	struct device_info Device ;     /* Device Info */
	vendor_class_opt vendoropt;     /* V-I Vendor Class option */
	const char *gsconf;             /* GS rc.conf */
} FIX_ALIASING;

/* server_config sits in 1st half of bb_common_bufsiz1 */
#define client_config (*(struct client_config_t*)(&bb_common_bufsiz1[COMMON_BUFSIZE / 2]))

#if ENABLE_FEATURE_UDHCP_PORT
#define CLIENT_PORT  (client_config.port)
#define CLIENT_PORT6 (client_config.port)
#else
#define CLIENT_PORT  68
#define CLIENT_PORT6 546
#endif

POP_SAVED_FUNCTION_VISIBILITY

#endif
