#!/bin/bash

source /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

CDIR=`pwd`
CACHEFILE="arm-linux.cache"
REL_LIB_DIR="../../../../ht/image_build/image_source/base/usr/lib"
TOOLCHAIN_LIB_DIR="${SDKTARGETSYSROOT}/usr/lib"
TOOLCHAIN_INC_DIR="${SDKTARGETSYSROOT}/usr/include"
C_ARES_DIR="../c-ares-1.10.0"

if [ "$1" = "configure" ];then
    [ ! -e "${TOOLCHAIN_LIB_DIR}/libcares.so" ] && sudo -E cp ${REL_LIB_DIR}/libcares.so* ${TOOLCHAIN_LIB_DIR}/
    #[ ! -e "${TOOLCHAIN_LIB_DIR}/libnvram.so" ] && sudo -E cp ${REL_LIB_DIR}/libnvram.so* ${TOOLCHAIN_LIB_DIR}/
    #[ ! -e "${TOOLCHAIN_LIB_DIR}/libpvalue_validation.so" ] && sudo -E cp ${REL_LIB_DIR}/libpvalue_validation.so* ${TOOLCHAIN_LIB_DIR}/
    [ ! -e "${TOOLCHAIN_INC_DIR}/ares.h" ] && sudo -E cp ${C_ARES_DIR}/*.h ${TOOLCHAIN_INC_DIR}/
    [ -e ${CACHEFILE} ] && rm -f ${CACHEFILE} 
    ./configure --host=arm-dspg-linux-gnueabi --disable-ssh --enable-ipv6 --disable-dict --disable-file --disable-gopher --disable-imap --disable-ldap --disable-imaps --disable-pop3 --disable-pop3s --disable-rtsp --disable-smtp --disable-smtps --disable-telnet --enable-tftp --enable-ares --cache-file=${CACHEFILE}
fi

OPENSSL_INCLUDE="${CDIR}/../openssl-1.0.2j/include"
export C_INCLUDE_PATH=${OPENSSL_INCLUDE}:${C_INCLUDE_PATH}
make clean && make

cp ./lib/.libs/libcurl.so* ${REL_LIB_DIR}/
