#!/bin/bash

CDIR=`pwd`
. /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

HEADER_DIR=/opt/dspg/v2.3.0-rc2/sysroots/cortexa9-neon-dspg-linux-gnueabi/usr/include

mkdir glibc_build glibc_install
cd glibc_build

if [ x$1 = xclean ];then
	make clean
	cd $CDIR
	exit
fi

echo ac_cv_path_PERL=/usr/bin/perl >>config.cache
$CDIR/configure ${CONFIGURE_FLAGS} \
	--cache-file=config.cache \
	--prefix=/usr \
	--exec_prefix=/usr \
	--bindir=/usr/bin \
	--sbindir=/usr/sbin \
	--libexecdir=/usr/libexec \
	--datadir=/usr/share \
	--sysconfdir=/etc \
	--sharedstatedir=/com \
	--localstatedir=/var \
	--libdir=/usr/lib \
	--includedir=/usr/include \
	--oldincludedir=/usr/include \
	--infodir=/usr/share/info \
	--mandir=/usr/share/man \
	--disable-silent-rules \
	--disable-dependency-tracking \
	--enable-kernel=3.2.0 \
	--without-cvs \
	--disable-profile \
	--disable-debug \
	--without-gd \
	--enable-clocale=gnu \
	--enable-add-ons \
	--with-headers=${HEADER_DIR} \
	--without-selinux \
	--enable-obsolete-rpc \
	--enable-nscd

make 
make install DESTDIR=$CDIR/glibc_install

cd $CDIR
