#!/bin/bash

set -e

BUILD_LIST="libnfnetlink-1.0.1 \
	libmnl-1.0.4 \
	libnftnl-1.0.7 \
	iptables-1.6.0
"

CDIR="`pwd`"
BOUT=./build_out

usage() {
	echo "$0 [|configure|clean|distclean]"
}

if [ x$1 != x ];then
	case $1 in
	configure);;
	clean);;
	distclean)
		if [ -r $BOUT ];then
			rm -rf $BOUT
		fi
		;;
	*)
		usage
		exit 0
	esac
fi

for BDIR in ${BUILD_LIST}
do
	cd $BDIR
	./build.sh $1
	cd $CDIR
done




