#!/bin/bash

. /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

CURDIR=`pwd`
BUILD_OUT=${CURDIR}/../build_out
BUILD_INC=${CURDIR}/../build_out/include
BUILD_LIBS=${CURDIR}/../build_out/lib

if [ "$1" = "clean" ] || [ "$1" = "distclean" ];then
	make $1
	exit
fi

#prevent autoconfig
touch Makefile.in
touch aclocal.m4

mkdir -p $BUILD_OUT
if [ "$1" = "configure" ];then
	libnfnetlink_CFLAGS="-I$BUILD_INC" \
	libnfnetlink_LIBS="-L$BUILD_LIBS -lnfnetlink" \
	libnftnl_CFLAGS="-I$BUILD_INC" \
	libnftnl_LIBS="-L$BUILD_LIBS -lnftnl" \
	libmnl_CFLAGS="-I$BUILD_INC" \
	libmnl_LIBS="-L$BUILD_LIBS -lmnl" \
	./configure ${CONFIGURE_FLAGS} \
		--prefix=/usr \
		--disable-silent-rules \
		--disable-dependency-tracking \
		--enable-ipv6 \
		--disable-libnfnetlink \
		--disable-nftables
fi

make clean
make
make install DESTDIR=${BUILD_OUT}
