#!/bin/bash

CDIR=`pwd`
PCRE_BUILDOUT=${CDIR}/../buildout/app/lighttpd
INSTALL_DIR=${CDIR}/../buildout
INSTALL_PREFIX=/app/lighttpd

. /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

export PCRECONFIG=${PCRE_BUILDOUT}/bin/pcre-config
export CFLAGS="$CFLAGS -DHAVE_PCRE_H=1 -DHAVE_LIBPCRE=1 -I${PCRE_BUILDOUT}/include"

if [ x$1 = xclean ];then
	make clean
	exit 0
fi

if [ x$1 = x-configure ];then
#LIGHTTPD_STATIC=yes
#CPPFLAGS=-DLIGHTTPD_STATIC
	make distclean
	./configure \
		${CONFIGURE_FLAGS} \
		--prefix=${INSTALL_PREFIX} \
		--without-mysql \
		--without-zlib \
		--with-openssl \
		--without-bzip2 \
		--disable-lfs \
		--libdir=/app/lighttpd/lib
		#ac_cv_path_PCRECONFIG=/opt/lighttpd-1.4.35/pcre-config
fi

#make clean 
make clean && make
make install DESTDIR=$INSTALL_DIR
