/*
 *  arch/arm/include/asm/hardware/plicu.h
 *
 * Copyright (c) 2012 DSPG Technologies GmbH
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __ASM_ARM_HARDWARE_PLICU_H
#define __ASM_ARM_HARDWARE_PLICU_H

#define PLICU_CH_CLR_INT1	0x00
#define PLICU_CH_CLR_INT2	0x04
#define PLICU_CH_EDGE_LEVEL1	0x08
#define PLICU_CH_EDGE_LEVEL2	0x0C
#define PLICU_CH_SW_TRIG_SET1	0x10
#define PLICU_CH_SW_TRIG_SET2	0x14
#define PLICU_SW_CH_REQ		0x18
#define PLICU_STATUS1		0x1C
#define PLICU_STATUS2		0x20
#define PLICU_PENDING_REQ1	0x24
#define PLICU_PENDING_REQ2	0x28
#define PLICU_CAUSE1		0x2C
#define PLICU_CAUSE2		0x30
#define PLICU_CH_MASK1		0x34
#define PLICU_CH_MASK2		0x38
#define PLICU_SET_CH_MASK1	0x3C
#define PLICU_SET_CH_MASK2	0x40
#define PLICU_CLR_CH_MASK1	0x44
#define PLICU_CLR_CH_MASK2	0x48
#define PLICU_CH_PRIORITY1	0x4C
#define PLICU_CH_PRIORITY2	0x50
#define PLICU_CH_PRIORITY3	0x54
#define PLICU_CH_PRIORITY4	0x58
#define PLICU_CH_PRIORITY5	0x5C
#define PLICU_CH_PRIORITY6	0x60
#define PLICU_CH_PRIORITY7	0x64
#define PLICU_CH_PRIORITY8	0x68
#define PLICU_FIQ_SEL1		0x6C
#define PLICU_FIQ_SEL2		0x70
#define PLICU_FIQ_PENDING_REQ1	0x74
#define PLICU_FIQ_PENDING_REQ2	0x78
#define PLICU_FIQ_CAUSE1	0x7C
#define PLICU_FIQ_CAUSE2	0x80
#define PLICU_PRI_MASK		0x84
#define PLICU_PRI_MASK_FIQ	0x88

#ifndef __ASSEMBLY__
#include <linux/compiler.h>
#include <linux/types.h>

struct device_node;
struct pt_regs;

int plicu_init(struct device_node *node, struct device_node *parent);
void plicu_handle_irq(struct pt_regs *regs);
int plicu_pending(void);

#endif /* __ASSEMBLY__ */
#endif
