#!/bin/bash

# NOTE:
# make menuconfig
# make savedefconfig
# mv defconfig arch/arm/configs/${1}_defconfig

. /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

CPU=`cat /proc/cpuinfo | grep -c processor`

RELEASE_KERNEL_DIR=../../../../ht/image_build/image_source/bin
RELEASE_MODULES_DIR=../../../../ht/image_build/image_source/base
RELEASE_FACT_DIR=../../../closesource/fact_cfg/factpara

release_kernel() {
	cp -v arch/arm/boot/uImage $RELEASE_KERNEL_DIR/core.$1.dev
}

check_status() {
	if [ "$?" != "0" ]; then
		echo "**** Error: Build fails!"
		exit 1
	fi
}

usage() {
	echo "./build.sh <target>"
	echo "	Valid Targets: ht818"
	tree --noreport arch/arm/boot/dts/grandstream  -P "*.dts"
}

build_uimage() {
	echo "Building kernel image for ${1}_defconfig"
	make ${1}_defconfig
	make uImage -j$CPU 
	check_status

#	make modules -j$CPU
#	make INSTALL_MOD_PATH=$RELEASE_MODULES_DIR modules_install
}

build_devtree() {
	local dtslist=`ls -1 arch/arm/boot/dts/grandstream/${1}*.dts`
	local dt_dir=$(echo $1 | tr '[a-z]' '[A-Z]')
	for DTS in $dtslist
	do
		local dts_target="grandstream/`echo ${DTS##*/} |sed 's/.dts/.dtb/g'`"
		make $dts_target
		cp -v arch/arm/boot/dts/$dts_target $RELEASE_FACT_DIR/${dt_dir}/devtree/
	done
}

if [ x"$1" = x ]; then
    usage
    exit
else
    PRODUCTS=$1
fi

for i in $PRODUCTS; do
    build_uimage $i
	build_devtree $i
	release_kernel $i
done
