/*
 * gs_slic.h  --  Silicon Labs SPI driver header
 *
 * Copyright (C) 2017 Grandstream, Inc
 *
 * 20170608  jwli@grandstream.cn
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef __GS_SLIC_H__
#define __GS_SLIC_H__

#include <linux/ioctl.h> /* needed for the _IOW etc stuff used later */
#include <linux/spi/spi.h>

#define NUM_SPI_BANKS		(8)

struct gs_slic_spidev_data {
	dev_t			devt;
	spinlock_t		spi_lock;
	struct spi_device	*spi;
	struct list_head	device_entry;
	struct mutex		buf_lock;
	unsigned		users;
	u8			*buffer;
};

struct gs_slic_platform_data {
	unsigned int reset;
	unsigned int id;
};

/* codec private data */

struct gs_slic_priv {
	struct spi_device *spi;
	unsigned int reset;
	unsigned int id;
	int cs;
};

int  gs_slic_spidev_probe(struct spi_device *spi);
int  gs_slic_spidev_remove(struct spi_device *spi);
int  gs_slic_spidev_init(void);
void gs_slic_spidev_exit(void);
void gs_slic_reset(unsigned int gpio);

#endif /* __GS_SLIC_H__ */
