/*
 * This header provides constants for binding dspg-gpio/pinctrl controller
 *
 * The first two cells in DSPG's GPIO specifier are the bank and GPIO number.
 * The third cell contains standard flag values specified in gpio.h and
 * additional flags defined in this file.
 */

#ifndef _DT_BINDINGS_GPIO_DSPG_H
#define _DT_BINDINGS_GPIO_DSPG_H

#include <dt-bindings/gpio/gpio.h>

#define GPIO_PULL_UP      (1 << 1 | 1 << 2 | 1 << 3)
#define GPIO_PULL_DOWN    (1 << 1 | 1 << 2)
#define GPIO_PULL_DISABLE (1 << 1)

#define GPIO_SLEW_FAST    (1 << 4 | 1 << 5)
#define GPIO_SLEW_SLOW    (1 << 4)

#endif
