/*
 * include/linux/clksrc-dspg-tmr.h
 *
 * Copyright (C) 2013 DSP Group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LINUX_CLKSRC_DSPG_TMR_H
#define __LINUX_CLKSRC_DSPG_TMR_H

#include <linux/init.h>

struct dspg_tmr;
struct device_node;

struct dspg_tmr * __init dspg_tmr_clockevent_init(struct device_node *node);
void __init dspg_tmr_register_clockevent(struct dspg_tmr *tmr);

unsigned long dspg_tmr_read(struct dspg_tmr *tmr);
unsigned long dspg_tmr_rate(struct dspg_tmr *tmr);
void dspg_tmr_persistent_clock(struct dspg_tmr *tmr, struct timespec64 *ts);

struct dspg_tmr * __init dspg_tmr_clocksource_init(struct device_node *node);
int __init dspg_tmr_register_clocksource(struct dspg_tmr *tmr);

#endif
