#ifndef _LINUX_MFD_DVF9A_H
#define _LINUX_MFD_DVF9A_H

#include <uapi/linux/dvf9a.h>

struct dvf9a;

unsigned short daif_read(struct dvf9a *dvf9a, unsigned short reg);
void daif_write(struct dvf9a *dvf9a, unsigned short reg, unsigned short value);
int daif_translate_irq(struct dvf9a *dvf9a, int hw_irq);
void dvf9a_handle_ownership(struct dvf9a *dvf9a, void (*handle)(struct dvf9a *));
void dvf9a_acquire(struct dvf9a *dvf9a);
void dvf9a_set_owner(struct dvf9a *dvf9a, int owner);

#define DVF9A_IOC_MAGIC		'A'
#define DVF9A_IOC_REQ_IRQ	_IOWR(DVF9A_IOC_MAGIC, 0, int)
#define DVF9A_IOC_REL_IRQ	_IOW (DVF9A_IOC_MAGIC, 1, int)

#endif /* _LINUX_MFD_DVF9A_H */
