/*
 * include/uapi/linux/coma/coma-sharedmem.h - shared memory allocation service
 *
 * Copyright (C) 2013 DSP Group Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _UAPI_LINUX_COMA_SHAREDMEM_H
#define _UAPI_LINUX_COMA_SHAREDMEM_H

struct sharedmem_coma_handle {
	unsigned long pa;
	unsigned int size;
	unsigned long css_va;
	void *user;
};

struct sharedmem_coma_info {
	unsigned long base;
	unsigned int size;
};

#define SHAREDMEM_IOC_MAGIC	'S'
#define SHAREDMEM_IOCALLOC	_IOWR(SHAREDMEM_IOC_MAGIC, 0, struct sharedmem_coma_handle *)
#define SHAREDMEM_IOCFREE	_IOWR(SHAREDMEM_IOC_MAGIC, 1, struct sharedmem_coma_handle *)
#define SHAREDMEM_IOCINFO	_IOWR(SHAREDMEM_IOC_MAGIC, 2, struct sharedmem_coma_info *)
#define SHAREDMEM_IOC_MAXNR	2

#endif /* _UAPI_LINUX_COMA_SHAREDMEM_H */
