/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */
#include <errno.h>
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "grandstream.h"
#include "nvram.h"

#include <limits.h>

in_addr_t get_nvram_addr( const char *name )
{
    struct in_addr ipaddress ;
    char buffer[256] = { 0 } ;

    nvram_get_safe( name, buffer, 256 ) ;

    if( buffer[0] == 0 )
        return -1 ;

    if( inet_aton( buffer, &ipaddress ) == 0 )
        return -1 ; 
    return ipaddress.s_addr ;
}

long get_nvram_long( const char *name, int *empty )
{
    long value = 0 ;
    char buffer[256] = { 0 }, *endptr = NULL ;

    nvram_get_safe( name, buffer, 256 ) ;

    if( buffer[0] == 0 )
    {
        *empty = 1 ;
        return 0 ;
    }
    else
    {
        errno = 0 ;
        value = strtol( buffer, &endptr, 10 ) ;
        if ( (errno == ERANGE && ( value == LONG_MAX ||  value == LONG_MIN))
              || (errno != 0 &&  value == 0))
        {
            *empty = 1 ;
            return 0 ;
        }
        if (endptr == buffer )
        {
            *empty = 1 ;
            return 0 ;
        }
    }
    return value ;
}

const oid PartNo_oid[] = { 1,3,6,1,4,1,42397,1,2,1, 0 } ;
const oid networkMode_oid[] = { 1,3,6,1,4,1,42397,1,2,4,1, 0 } ;
const oid pppoeLink_oid[] = { 1,3,6,1,4,1,42397,1,2,4,2, 0 } ;
const oid natTraversal1_oid[] = { 1,3,6,1,4,1,42397,1,2,4,3, 0 } ;
const oid natTraversal2_oid[] = { 1,3,6,1,4,1,42397,1,2,4,4, 0 } ;
const oid versionBoot_oid[] = { 1,3,6,1,4,1,42397,1,2,3,1, 0 } ;
const oid versionCore_oid[] = { 1,3,6,1,4,1,42397,1,2,3,2, 0 } ;
const oid versionBase_oid[] = { 1,3,6,1,4,1,42397,1,2,3,3, 0 } ;
const oid versionProg_oid[] = { 1,3,6,1,4,1,42397,1,2,3,4, 0 } ;
const oid hookStatus1_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,1, 0 } ;
const oid hookStatus2_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,2, 0 } ;
const oid hookStatus3_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,3, 0 } ;
const oid hookStatus4_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,4, 0 } ;
const oid hookStatus5_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,5, 0 } ;
const oid hookStatus6_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,6, 0 } ;
const oid hookStatus7_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,7, 0 } ;
const oid hookStatus8_oid[] = { 1,3,6,1,4,1,42397,1,2,2,1,8, 0 } ;
const oid regStatus1_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,1, 0 } ;
const oid regStatus2_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,2, 0 } ;
const oid regStatus3_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,3, 0 } ;
const oid regStatus4_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,4, 0 } ;
const oid regStatus5_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,5, 0 } ;
const oid regStatus6_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,6, 0 } ;
const oid regStatus7_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,7, 0 } ;
const oid regStatus8_oid[] = { 1,3,6,1,4,1,42397,1,2,2,2,8, 0 } ;
const oid dnd1_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,1, 0 } ;
const oid dnd2_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,2, 0 } ;
const oid dnd3_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,3, 0 } ;
const oid dnd4_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,4, 0 } ;
const oid dnd5_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,5, 0 } ;
const oid dnd6_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,6, 0 } ;
const oid dnd7_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,7, 0 } ;
const oid dnd8_oid[] = { 1,3,6,1,4,1,42397,1,2,2,3,8, 0 } ;
const oid forward1_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,1, 0 } ;
const oid forward2_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,2, 0 } ;
const oid forward3_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,3, 0 } ;
const oid forward4_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,4, 0 } ;
const oid forward5_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,5, 0 } ;
const oid forward6_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,6, 0 } ;
const oid forward7_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,7, 0 } ;
const oid forward8_oid[] = { 1,3,6,1,4,1,42397,1,2,2,4,8, 0 } ;
const oid busyForward1_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,1, 0 } ;
const oid busyForward2_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,2, 0 } ;
const oid busyForward3_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,3, 0 } ;
const oid busyForward4_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,4, 0 } ;
const oid busyForward5_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,5, 0 } ;
const oid busyForward6_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,6, 0 } ;
const oid busyForward7_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,7, 0 } ;
const oid busyForward8_oid[] = { 1,3,6,1,4,1,42397,1,2,2,5,8, 0 } ;
const oid delayedForward1_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,1, 0 } ;
const oid delayedForward2_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,2, 0 } ;
const oid delayedForward3_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,3, 0 } ;
const oid delayedForward4_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,4, 0 } ;
const oid delayedForward5_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,5, 0 } ;
const oid delayedForward6_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,6, 0 } ;
const oid delayedForward7_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,7, 0 } ;
const oid delayedForward8_oid[] = { 1,3,6,1,4,1,42397,1,2,2,6,8, 0 } ;

/** Initializes the grandstream module */
void
init_grandstream(void)
{
    DEBUGMSGTL(("grandstream", "Initializing\n"));

    snmp_alarm_register( 1, /* seconds */
        SA_REPEAT,                      /* repeat */
        send_TimedTrap_notification,         /* our callback */
        NULL                            /* no callback data needed */
     );

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("PartNo", handle_PartNo,
                               PartNo_oid, OID_LENGTH(PartNo_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus1", handle_hookStatus1,
                               hookStatus1_oid, OID_LENGTH(hookStatus1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus2", handle_hookStatus2,
                               hookStatus2_oid, OID_LENGTH(hookStatus2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus3", handle_hookStatus3,
                               hookStatus3_oid, OID_LENGTH(hookStatus3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus4", handle_hookStatus4,
                               hookStatus4_oid, OID_LENGTH(hookStatus4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus5", handle_hookStatus5,
                               hookStatus5_oid, OID_LENGTH(hookStatus5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus6", handle_hookStatus6,
                               hookStatus6_oid, OID_LENGTH(hookStatus6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus7", handle_hookStatus7,
                               hookStatus7_oid, OID_LENGTH(hookStatus7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("hookStatus8", handle_hookStatus8,
                               hookStatus8_oid, OID_LENGTH(hookStatus8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus1", handle_regStatus1,
                               regStatus1_oid, OID_LENGTH(regStatus1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus2", handle_regStatus2,
                               regStatus2_oid, OID_LENGTH(regStatus2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus3", handle_regStatus3,
                               regStatus3_oid, OID_LENGTH(regStatus3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus4", handle_regStatus4,
                               regStatus4_oid, OID_LENGTH(regStatus4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus5", handle_regStatus5,
                               regStatus5_oid, OID_LENGTH(regStatus5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus6", handle_regStatus6,
                               regStatus6_oid, OID_LENGTH(regStatus6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus7", handle_regStatus7,
                               regStatus7_oid, OID_LENGTH(regStatus7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("regStatus8", handle_regStatus8,
                               regStatus8_oid, OID_LENGTH(regStatus8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd1", handle_dnd1,
                               dnd1_oid, OID_LENGTH(dnd1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd2", handle_dnd2,
                               dnd2_oid, OID_LENGTH(dnd2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd3", handle_dnd3,
                               dnd3_oid, OID_LENGTH(dnd3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd4", handle_dnd4,
                               dnd4_oid, OID_LENGTH(dnd4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd5", handle_dnd5,
                               dnd5_oid, OID_LENGTH(dnd5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd6", handle_dnd6,
                               dnd6_oid, OID_LENGTH(dnd6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd7", handle_dnd7,
                               dnd7_oid, OID_LENGTH(dnd7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dnd8", handle_dnd8,
                               dnd8_oid, OID_LENGTH(dnd8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward1", handle_forward1,
                               forward1_oid, OID_LENGTH(forward1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward2", handle_forward2,
                               forward2_oid, OID_LENGTH(forward2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward3", handle_forward3,
                               forward3_oid, OID_LENGTH(forward3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward4", handle_forward4,
                               forward4_oid, OID_LENGTH(forward4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward5", handle_forward5,
                               forward5_oid, OID_LENGTH(forward5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward6", handle_forward6,
                               forward6_oid, OID_LENGTH(forward6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward7", handle_forward7,
                               forward7_oid, OID_LENGTH(forward7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("forward8", handle_forward8,
                               forward8_oid, OID_LENGTH(forward8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward1", handle_busyForward1,
                               busyForward1_oid, OID_LENGTH(busyForward1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward2", handle_busyForward2,
                               busyForward2_oid, OID_LENGTH(busyForward2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward3", handle_busyForward3,
                               busyForward3_oid, OID_LENGTH(busyForward3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward4", handle_busyForward4,
                               busyForward4_oid, OID_LENGTH(busyForward4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward5", handle_busyForward5,
                               busyForward5_oid, OID_LENGTH(busyForward5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward6", handle_busyForward6,
                               busyForward6_oid, OID_LENGTH(busyForward6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward7", handle_busyForward7,
                               busyForward7_oid, OID_LENGTH(busyForward7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("busyForward8", handle_busyForward8,
                               busyForward8_oid, OID_LENGTH(busyForward8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward1", handle_delayedForward1,
                               delayedForward1_oid, OID_LENGTH(delayedForward1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward2", handle_delayedForward2,
                               delayedForward2_oid, OID_LENGTH(delayedForward2_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward3", handle_delayedForward3,
                               delayedForward3_oid, OID_LENGTH(delayedForward3_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward4", handle_delayedForward4,
                               delayedForward4_oid, OID_LENGTH(delayedForward4_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward5", handle_delayedForward5,
                               delayedForward5_oid, OID_LENGTH(delayedForward5_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward6", handle_delayedForward6,
                               delayedForward6_oid, OID_LENGTH(delayedForward6_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward7", handle_delayedForward7,
                               delayedForward7_oid, OID_LENGTH(delayedForward7_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("delayedForward8", handle_delayedForward8,
                               delayedForward8_oid, OID_LENGTH(delayedForward8_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionBoot", handle_versionBoot,
                               versionBoot_oid, OID_LENGTH(versionBoot_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionCore", handle_versionCore,
                               versionCore_oid, OID_LENGTH(versionCore_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionBase", handle_versionBase,
                               versionBase_oid, OID_LENGTH(versionBase_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("versionProg", handle_versionProg,
                               versionProg_oid, OID_LENGTH(versionProg_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("networkMode", handle_networkMode,
                               networkMode_oid, OID_LENGTH(networkMode_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("pppoeLink", handle_pppoeLink,
                               pppoeLink_oid, OID_LENGTH(pppoeLink_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("natTraversal1", handle_natTraversal1,
                               natTraversal1_oid, OID_LENGTH(natTraversal1_oid),
                               HANDLER_CAN_RONLY
        ));
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("natTraversal2", handle_natTraversal2,
                               natTraversal2_oid, OID_LENGTH(natTraversal2_oid),
                               HANDLER_CAN_RONLY
        ));
}

void
send_TimedTrap_notification( unsigned int clientreg, void *clientarg )
{
    netsnmp_variable_list  *var_list = NULL ;
    const oid TimedTrap_oid[] = { 1,3,6,1,4,1,42397,1,2,5,1 } ;
    int pvalue_empty =  0 ;
    int v3trap = 0;

    oid snmptrap_oid[] = { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 } ;
    size_t snmptrap_oid_len = OID_LENGTH( snmptrap_oid ) ;
    char *ptr_no_of_ports = NULL ;
    int no_of_ports = 16 ;

    char PartNo_value[256] = { 0 } ;
    char *PartNo_ptr = NULL ;
    long networkMode_value = 0 ;
    long pppoeLink_value = 0 ;
    long natTraversal1_value = 0 ;
    long natTraversal2_value = 0 ;
    char versionBoot_value[256] = { 0 } ;
    char *versionBoot_ptr = NULL ;
    char versionCore_value[256] = { 0 } ;
    char *versionCore_ptr = NULL ;
    char versionBase_value[256] = { 0 } ;
    char *versionBase_ptr = NULL ;
    char versionProg_value[256] = { 0 } ;
    char *versionProg_ptr = NULL ;
    char hookStatus1_value[256] = { 0 } ;
    char *hookStatus1_ptr = NULL ;
    char hookStatus2_value[256] = { 0 } ;
    char *hookStatus2_ptr = NULL ;
    char hookStatus3_value[256] = { 0 } ;
    char *hookStatus3_ptr = NULL ;
    char hookStatus4_value[256] = { 0 } ;
    char *hookStatus4_ptr = NULL ;
    char hookStatus5_value[256] = { 0 } ;
    char *hookStatus5_ptr = NULL ;
    char hookStatus6_value[256] = { 0 } ;
    char *hookStatus6_ptr = NULL ;
    char hookStatus7_value[256] = { 0 } ;
    char *hookStatus7_ptr = NULL ;
    char hookStatus8_value[256] = { 0 } ;
    char *hookStatus8_ptr = NULL ;
    char regStatus1_value[256] = { 0 } ;
    char *regStatus1_ptr = NULL ;
    char regStatus2_value[256] = { 0 } ;
    char *regStatus2_ptr = NULL ;
    char regStatus3_value[256] = { 0 } ;
    char *regStatus3_ptr = NULL ;
    char regStatus4_value[256] = { 0 } ;
    char *regStatus4_ptr = NULL ;
    char regStatus5_value[256] = { 0 } ;
    char *regStatus5_ptr = NULL ;
    char regStatus6_value[256] = { 0 } ;
    char *regStatus6_ptr = NULL ;
    char regStatus7_value[256] = { 0 } ;
    char *regStatus7_ptr = NULL ;
    char regStatus8_value[256] = { 0 } ;
    char *regStatus8_ptr = NULL ;
    long dnd1_value = 0 ;
    long dnd2_value = 0 ;
    long dnd3_value = 0 ;
    long dnd4_value = 0 ;
    long dnd5_value = 0 ;
    long dnd6_value = 0 ;
    long dnd7_value = 0 ;
    long dnd8_value = 0 ;
    char forward1_value[256] = { 0 } ;
    char *forward1_ptr = NULL ;
    char forward2_value[256] = { 0 } ;
    char *forward2_ptr = NULL ;
    char forward3_value[256] = { 0 } ;
    char *forward3_ptr = NULL ;
    char forward4_value[256] = { 0 } ;
    char *forward4_ptr = NULL ;
    char forward5_value[256] = { 0 } ;
    char *forward5_ptr = NULL ;
    char forward6_value[256] = { 0 } ;
    char *forward6_ptr = NULL ;
    char forward7_value[256] = { 0 } ;
    char *forward7_ptr = NULL ;
    char forward8_value[256] = { 0 } ;
    char *forward8_ptr = NULL ;
    char busyForward1_value[256] = { 0 } ;
    char *busyForward1_ptr = NULL ;
    char busyForward2_value[256] = { 0 } ;
    char *busyForward2_ptr = NULL ;
    char busyForward3_value[256] = { 0 } ;
    char *busyForward3_ptr = NULL ;
    char busyForward4_value[256] = { 0 } ;
    char *busyForward4_ptr = NULL ;
    char busyForward5_value[256] = { 0 } ;
    char *busyForward5_ptr = NULL ;
    char busyForward6_value[256] = { 0 } ;
    char *busyForward6_ptr = NULL ;
    char busyForward7_value[256] = { 0 } ;
    char *busyForward7_ptr = NULL ;
    char busyForward8_value[256] = { 0 } ;
    char *busyForward8_ptr = NULL ;
    char delayedForward1_value[256] = { 0 } ;
    char *delayedForward1_ptr = NULL ;
    char delayedForward2_value[256] = { 0 } ;
    char *delayedForward2_ptr = NULL ;
    char delayedForward3_value[256] = { 0 } ;
    char *delayedForward3_ptr = NULL ;
    char delayedForward4_value[256] = { 0 } ;
    char *delayedForward4_ptr = NULL ;
    char delayedForward5_value[256] = { 0 } ;
    char *delayedForward5_ptr = NULL ;
    char delayedForward6_value[256] = { 0 } ;
    char *delayedForward6_ptr = NULL ;
    char delayedForward7_value[256] = { 0 } ;
    char *delayedForward7_ptr = NULL ;
    char delayedForward8_value[256] = { 0 } ;
    char *delayedForward8_ptr = NULL ;

    /*run trap only if pvalue is set to 1*/
    char *pinterval = nvram_get( ":SNMP_trap_1" ) ; /*FILL IN pvalue*/
    if( pinterval == NULL || pinterval[0] == 0 )
            return ;
    if( atoi( pinterval ) == 1 )
        v3trap = 0;
    else if(atoi( pinterval ) == 3 )
        v3trap = 1;
    else
        return ;
    nvram_set( ":SNMP_trap_1", "0" ) ; /*FILL IN pvalue*/

    ptr_no_of_ports = nvram_get( ":num_of_ports" ) ;
    if( ptr_no_of_ports == NULL || ptr_no_of_ports[0] == 0 )
        no_of_ports = 1 ;
    else
    {
        no_of_ports = atoi( ptr_no_of_ports ) ;
        if( no_of_ports <= 0 )
            no_of_ports = 1 ;
    }

    memset( PartNo_value, 0, 256 )  ;
    PartNo_ptr = NULL  ;
    networkMode_value = 0 ;
    pppoeLink_value = 0 ;
    natTraversal1_value = 0 ;
    natTraversal2_value = 0 ;
    memset( versionBoot_value, 0, 256 )  ;
    versionBoot_ptr = NULL  ;
    memset( versionCore_value, 0, 256 )  ;
    versionCore_ptr = NULL  ;
    memset( versionBase_value, 0, 256 )  ;
    versionBase_ptr = NULL  ;
    memset( versionProg_value, 0, 256 )  ;
    versionProg_ptr = NULL  ;
    memset( hookStatus1_value, 0, 256 )  ;
    hookStatus1_ptr = NULL  ;
    if ( no_of_ports > 1 )
    {
    memset( hookStatus2_value, 0, 256 )  ;
    hookStatus2_ptr = NULL  ;
    if ( no_of_ports > 2 )
    {
    memset( hookStatus3_value, 0, 256 )  ;
    hookStatus3_ptr = NULL  ;
    memset( hookStatus4_value, 0, 256 )  ;
    hookStatus4_ptr = NULL  ;
    if ( no_of_ports > 4 )
    {
    memset( hookStatus5_value, 0, 256 )  ;
    hookStatus5_ptr = NULL  ;
    memset( hookStatus6_value, 0, 256 )  ;
    hookStatus6_ptr = NULL  ;
    memset( hookStatus7_value, 0, 256 )  ;
    hookStatus7_ptr = NULL  ;
    memset( hookStatus8_value, 0, 256 )  ;
    hookStatus8_ptr = NULL  ;
    }}}
    memset( regStatus1_value, 0, 256 )  ;
    regStatus1_ptr = NULL  ;
    if ( no_of_ports > 1 )
    {
    memset( regStatus2_value, 0, 256 )  ;
    regStatus2_ptr = NULL  ;
    if ( no_of_ports > 2 )
    {
    memset( regStatus3_value, 0, 256 )  ;
    regStatus3_ptr = NULL  ;
    memset( regStatus4_value, 0, 256 )  ;
    regStatus4_ptr = NULL  ;
    if ( no_of_ports > 4 )
    {
    memset( regStatus5_value, 0, 256 )  ;
    regStatus5_ptr = NULL  ;
    memset( regStatus6_value, 0, 256 )  ;
    regStatus6_ptr = NULL  ;
    memset( regStatus7_value, 0, 256 )  ;
    regStatus7_ptr = NULL  ;
    memset( regStatus8_value, 0, 256 )  ;
    regStatus8_ptr = NULL  ;
    }}}
    dnd1_value = 0 ;
    if ( no_of_ports > 1 )
    {
    dnd2_value = 0 ;
    if ( no_of_ports > 2 )
    {
    dnd3_value = 0 ;
    dnd4_value = 0 ;
    if ( no_of_ports > 4 )
    {
    dnd5_value = 0 ;
    dnd6_value = 0 ;
    dnd7_value = 0 ;
    dnd8_value = 0 ;
    }}}
    memset( forward1_value, 0, 256 )  ;
    forward1_ptr = NULL  ;
    if ( no_of_ports > 1 )
    {
    memset( forward2_value, 0, 256 )  ;
    forward2_ptr = NULL  ;
    if ( no_of_ports > 2 )
    {
    memset( forward3_value, 0, 256 )  ;
    forward3_ptr = NULL  ;
    memset( forward4_value, 0, 256 )  ;
    forward4_ptr = NULL  ;
    if ( no_of_ports > 4 )
    {
    memset( forward5_value, 0, 256 )  ;
    forward5_ptr = NULL  ;
    memset( forward6_value, 0, 256 )  ;
    forward6_ptr = NULL  ;
    memset( forward7_value, 0, 256 )  ;
    forward7_ptr = NULL  ;
    memset( forward8_value, 0, 256 )  ;
    forward8_ptr = NULL  ;
    }}}
    memset( busyForward1_value, 0, 256 )  ;
    busyForward1_ptr = NULL  ;
    if ( no_of_ports > 1 )
    {
    memset( busyForward2_value, 0, 256 )  ;
    busyForward2_ptr = NULL  ;
    if ( no_of_ports > 2 )
    {
    memset( busyForward3_value, 0, 256 )  ;
    busyForward3_ptr = NULL  ;
    memset( busyForward4_value, 0, 256 )  ;
    busyForward4_ptr = NULL  ;
    if ( no_of_ports > 4 )
    {
    memset( busyForward5_value, 0, 256 )  ;
    busyForward5_ptr = NULL  ;
    memset( busyForward6_value, 0, 256 )  ;
    busyForward6_ptr = NULL  ;
    memset( busyForward7_value, 0, 256 )  ;
    busyForward7_ptr = NULL  ;
    memset( busyForward8_value, 0, 256 )  ;
    busyForward8_ptr = NULL  ;
    }}}
    memset( delayedForward1_value, 0, 256 )  ;
    delayedForward1_ptr = NULL  ;
    if ( no_of_ports > 1 )
    {
    memset( delayedForward2_value, 0, 256 )  ;
    delayedForward2_ptr = NULL  ;
    if ( no_of_ports > 2 )
    {
    memset( delayedForward3_value, 0, 256 )  ;
    delayedForward3_ptr = NULL  ;
    memset( delayedForward4_value, 0, 256 )  ;
    delayedForward4_ptr = NULL  ;
    if ( no_of_ports > 4 )
    {
    memset( delayedForward5_value, 0, 256 )  ;
    delayedForward5_ptr = NULL  ;
    memset( delayedForward6_value, 0, 256 )  ;
    delayedForward6_ptr = NULL  ;
    memset( delayedForward7_value, 0, 256 )  ;
    delayedForward7_ptr = NULL  ;
    memset( delayedForward8_value, 0, 256 )  ;
    delayedForward8_ptr = NULL  ;
    }}}

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
        snmptrap_oid, snmptrap_oid_len,
        ASN_OBJECT_ID,
        TimedTrap_oid, sizeof(TimedTrap_oid)) ;

    PartNo_ptr = nvram_get_safe( "1397", PartNo_value, 256 ) ; /* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    networkMode_value = get_nvram_long( "8", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    pppoeLink_value = get_nvram_long( "211", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    natTraversal1_value = get_nvram_long( "52", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    natTraversal2_value = get_nvram_long( "730", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    versionBoot_ptr = nvram_get_safe( "69", versionBoot_value, 256 ) ; /* CHECK pvalue or FILL in */
    versionCore_ptr = nvram_get_safe( "70", versionCore_value, 256 ) ; /* CHECK pvalue or FILL in */
    versionBase_ptr = nvram_get_safe( "45", versionBase_value, 256 ) ; /* CHECK pvalue or FILL in */
    versionProg_ptr = nvram_get_safe( "68", versionProg_value, 256 ) ; /* CHECK pvalue or FILL in */
    hookStatus1_ptr = nvram_get_safe( "4901", hookStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 1 )
    {
    hookStatus2_ptr = nvram_get_safe( "4902", hookStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 2 )
    {
    hookStatus3_ptr = nvram_get_safe( "4903", hookStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */
    hookStatus4_ptr = nvram_get_safe( "4904", hookStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 4 )
    {
    hookStatus5_ptr = nvram_get_safe( "4905", hookStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */
    hookStatus6_ptr = nvram_get_safe( "4906", hookStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */
    hookStatus7_ptr = nvram_get_safe( "4907", hookStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */
    hookStatus8_ptr = nvram_get_safe( "4908", hookStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */
    }}}
    regStatus1_ptr = nvram_get_safe( "4921", regStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 1 )
    {
    regStatus2_ptr = nvram_get_safe( "4922", regStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 2 )
    {
    regStatus3_ptr = nvram_get_safe( "4923", regStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */
    regStatus4_ptr = nvram_get_safe( "4924", regStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 4 )
    {
    regStatus5_ptr = nvram_get_safe( "4925", regStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */
    regStatus6_ptr = nvram_get_safe( "4926", regStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */
    regStatus7_ptr = nvram_get_safe( "4927", regStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */
    regStatus8_ptr = nvram_get_safe( "4928", regStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */
    }}}
    pvalue_empty = 0 ;
    dnd1_value = get_nvram_long( "dnd_0", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    if ( no_of_ports > 1 )
    {
    pvalue_empty = 0 ;
    dnd2_value = get_nvram_long( "dnd_1", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    if ( no_of_ports > 2 )
    {
    pvalue_empty = 0 ;
    dnd3_value = get_nvram_long( "dnd_2", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    dnd4_value = get_nvram_long( "dnd_3", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    if( no_of_ports > 4 )
    {
    pvalue_empty = 0 ;
    dnd5_value = get_nvram_long( "dnd_4", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    dnd6_value = get_nvram_long( "dnd_5", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    dnd7_value = get_nvram_long( "dnd_6", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    pvalue_empty = 0 ;
    dnd8_value = get_nvram_long( "dnd_7", &pvalue_empty ) ;/* CHECK pvalue or FILL in */
    }}}
    forward1_ptr = nvram_get_safe( "forward_0", forward1_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 1 )
    {
    forward2_ptr = nvram_get_safe( "forward_1", forward2_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 2 )
    {
    forward3_ptr = nvram_get_safe( "forward_2", forward3_value, 256 ) ; /* CHECK pvalue or FILL in */
    forward4_ptr = nvram_get_safe( "forward_3", forward4_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 4 )
    {
    forward5_ptr = nvram_get_safe( "forward_4", forward5_value, 256 ) ; /* CHECK pvalue or FILL in */
    forward6_ptr = nvram_get_safe( "forward_5", forward6_value, 256 ) ; /* CHECK pvalue or FILL in */
    forward7_ptr = nvram_get_safe( "forward_6", forward7_value, 256 ) ; /* CHECK pvalue or FILL in */
    forward8_ptr = nvram_get_safe( "forward_7", forward8_value, 256 ) ; /* CHECK pvalue or FILL in */
    }}}
    busyForward1_ptr = nvram_get_safe( "busyForward_0", busyForward1_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 1 )
    {
    busyForward2_ptr = nvram_get_safe( "busyForward_1", busyForward2_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 2 )
    {
    busyForward3_ptr = nvram_get_safe( "busyForward_2", busyForward3_value, 256 ) ; /* CHECK pvalue or FILL in */
    busyForward4_ptr = nvram_get_safe( "busyForward_3", busyForward4_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 4 )
    {
    busyForward5_ptr = nvram_get_safe( "busyForward_4", busyForward5_value, 256 ) ; /* CHECK pvalue or FILL in */
    busyForward6_ptr = nvram_get_safe( "busyForward_5", busyForward6_value, 256 ) ; /* CHECK pvalue or FILL in */
    busyForward7_ptr = nvram_get_safe( "busyForward_6", busyForward7_value, 256 ) ; /* CHECK pvalue or FILL in */
    busyForward8_ptr = nvram_get_safe( "busyForward_7", busyForward8_value, 256 ) ; /* CHECK pvalue or FILL in */
    }}}
    delayedForward1_ptr = nvram_get_safe( "delayedForward_0", delayedForward1_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 1 )
    {
    delayedForward2_ptr = nvram_get_safe( "delayedForward_1", delayedForward2_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 2 )
    {
    delayedForward3_ptr = nvram_get_safe( "delayedForward_2", delayedForward3_value, 256 ) ; /* CHECK pvalue or FILL in */
    delayedForward4_ptr = nvram_get_safe( "delayedForward_3", delayedForward4_value, 256 ) ; /* CHECK pvalue or FILL in */
    if ( no_of_ports > 4 )
    {
    delayedForward5_ptr = nvram_get_safe( "delayedForward_4", delayedForward5_value, 256 ) ; /* CHECK pvalue or FILL in */
    delayedForward6_ptr = nvram_get_safe( "delayedForward_5", delayedForward6_value, 256 ) ; /* CHECK pvalue or FILL in */
    delayedForward7_ptr = nvram_get_safe( "delayedForward_6", delayedForward7_value, 256 ) ; /* CHECK pvalue or FILL in */
    delayedForward8_ptr = nvram_get_safe( "delayedForward_7", delayedForward8_value, 256 ) ; /* CHECK pvalue or FILL in */
    }}}

    /*
     * Add any objects from the trap definition
     */
    if ( PartNo_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            PartNo_oid, OID_LENGTH(PartNo_oid),
            ASN_OCTET_STR,
            (u_char *)PartNo_ptr, strlen(PartNo_ptr) ) ;
    }
    snmp_varlist_add_variable(&var_list,
        networkMode_oid, OID_LENGTH(networkMode_oid),
        ASN_INTEGER,
        (u_char *)&networkMode_value, sizeof(networkMode_value) ) ;
    snmp_varlist_add_variable(&var_list,
        pppoeLink_oid, OID_LENGTH(pppoeLink_oid),
        ASN_INTEGER,
        (u_char *)&pppoeLink_value, sizeof(pppoeLink_value) ) ;
    snmp_varlist_add_variable(&var_list,
        natTraversal1_oid, OID_LENGTH(natTraversal1_oid),
        ASN_INTEGER,
        (u_char *)&natTraversal1_value, sizeof(natTraversal1_value) ) ;
    if ( no_of_ports > 1 )
    {
    snmp_varlist_add_variable(&var_list,
        natTraversal2_oid, OID_LENGTH(natTraversal2_oid),
        ASN_INTEGER,
        (u_char *)&natTraversal2_value, sizeof(natTraversal2_value) ) ;
    }
    if ( versionBoot_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionBoot_oid, OID_LENGTH(versionBoot_oid),
            ASN_OCTET_STR,
            (u_char *)versionBoot_ptr, strlen(versionBoot_ptr) ) ;
    }
    if ( versionCore_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionCore_oid, OID_LENGTH(versionCore_oid),
            ASN_OCTET_STR,
            (u_char *)versionCore_ptr, strlen(versionCore_ptr) ) ;
    }
    if ( versionBase_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionBase_oid, OID_LENGTH(versionBase_oid),
            ASN_OCTET_STR,
            (u_char *)versionBase_ptr, strlen(versionBase_ptr) ) ;
    }
    if ( versionProg_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            versionProg_oid, OID_LENGTH(versionProg_oid),
            ASN_OCTET_STR,
            (u_char *)versionProg_ptr, strlen(versionProg_ptr) ) ;
    }
    if ( hookStatus1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus1_oid, OID_LENGTH(hookStatus1_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus1_ptr, strlen(hookStatus1_ptr) ) ;
    }
    if ( hookStatus2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus2_oid, OID_LENGTH(hookStatus2_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus2_ptr, strlen(hookStatus2_ptr) ) ;
    }
    if ( hookStatus3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus3_oid, OID_LENGTH(hookStatus3_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus3_ptr, strlen(hookStatus3_ptr) ) ;
    }
    if ( hookStatus4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus4_oid, OID_LENGTH(hookStatus4_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus4_ptr, strlen(hookStatus4_ptr) ) ;
    }
    if ( hookStatus5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus5_oid, OID_LENGTH(hookStatus5_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus5_ptr, strlen(hookStatus5_ptr) ) ;
    }
    if ( hookStatus6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus6_oid, OID_LENGTH(hookStatus6_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus6_ptr, strlen(hookStatus6_ptr) ) ;
    }
    if ( hookStatus7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus7_oid, OID_LENGTH(hookStatus7_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus7_ptr, strlen(hookStatus7_ptr) ) ;
    }
    if ( hookStatus8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            hookStatus8_oid, OID_LENGTH(hookStatus8_oid),
            ASN_OCTET_STR,
            (u_char *)hookStatus8_ptr, strlen(hookStatus8_ptr) ) ;
    }
    if ( regStatus1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus1_oid, OID_LENGTH(regStatus1_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus1_ptr, strlen(regStatus1_ptr) ) ;
    }
    if ( regStatus2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus2_oid, OID_LENGTH(regStatus2_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus2_ptr, strlen(regStatus2_ptr) ) ;
    }
    if ( regStatus3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus3_oid, OID_LENGTH(regStatus3_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus3_ptr, strlen(regStatus3_ptr) ) ;
    }
    if ( regStatus4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus4_oid, OID_LENGTH(regStatus4_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus4_ptr, strlen(regStatus4_ptr) ) ;
    }
    if ( regStatus5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus5_oid, OID_LENGTH(regStatus5_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus5_ptr, strlen(regStatus5_ptr) ) ;
    }
    if ( regStatus6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus6_oid, OID_LENGTH(regStatus6_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus6_ptr, strlen(regStatus6_ptr) ) ;
    }
    if ( regStatus7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus7_oid, OID_LENGTH(regStatus7_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus7_ptr, strlen(regStatus7_ptr) ) ;
    }
    if ( regStatus8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            regStatus8_oid, OID_LENGTH(regStatus8_oid),
            ASN_OCTET_STR,
            (u_char *)regStatus8_ptr, strlen(regStatus8_ptr) ) ;
    }
    snmp_varlist_add_variable(&var_list,
        dnd1_oid, OID_LENGTH(dnd1_oid),
        ASN_INTEGER,
        (u_char *)&dnd1_value, sizeof(dnd1_value) ) ;
    if ( no_of_ports > 1 )
    {
    snmp_varlist_add_variable(&var_list,
        dnd2_oid, OID_LENGTH(dnd2_oid),
        ASN_INTEGER,
        (u_char *)&dnd2_value, sizeof(dnd2_value) ) ;
    if ( no_of_ports > 2 )
    {
    snmp_varlist_add_variable(&var_list,
        dnd3_oid, OID_LENGTH(dnd3_oid),
        ASN_INTEGER,
        (u_char *)&dnd3_value, sizeof(dnd3_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd4_oid, OID_LENGTH(dnd4_oid),
        ASN_INTEGER,
        (u_char *)&dnd4_value, sizeof(dnd4_value) ) ;
    if ( no_of_ports > 4 )
    {
    snmp_varlist_add_variable(&var_list,
        dnd5_oid, OID_LENGTH(dnd5_oid),
        ASN_INTEGER,
        (u_char *)&dnd5_value, sizeof(dnd5_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd6_oid, OID_LENGTH(dnd6_oid),
        ASN_INTEGER,
        (u_char *)&dnd6_value, sizeof(dnd6_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd7_oid, OID_LENGTH(dnd7_oid),
        ASN_INTEGER,
        (u_char *)&dnd7_value, sizeof(dnd7_value) ) ;
    snmp_varlist_add_variable(&var_list,
        dnd8_oid, OID_LENGTH(dnd8_oid),
        ASN_INTEGER,
        (u_char *)&dnd8_value, sizeof(dnd8_value) ) ;
	}}}
    if ( forward1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward1_oid, OID_LENGTH(forward1_oid),
            ASN_OCTET_STR,
            (u_char *)forward1_ptr, strlen(forward1_ptr) ) ;
    }
    if ( no_of_ports > 1 )
    {
    if ( forward2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward2_oid, OID_LENGTH(forward2_oid),
            ASN_OCTET_STR,
            (u_char *)forward2_ptr, strlen(forward2_ptr) ) ;
    }
    if ( no_of_ports > 2 )
    {
    if ( forward3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward3_oid, OID_LENGTH(forward3_oid),
            ASN_OCTET_STR,
            (u_char *)forward3_ptr, strlen(forward3_ptr) ) ;
    }
    if ( forward4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward4_oid, OID_LENGTH(forward4_oid),
            ASN_OCTET_STR,
            (u_char *)forward4_ptr, strlen(forward4_ptr) ) ;
    }
    if ( no_of_ports > 4 )
    {
    if ( forward5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward5_oid, OID_LENGTH(forward5_oid),
            ASN_OCTET_STR,
            (u_char *)forward5_ptr, strlen(forward5_ptr) ) ;
    }
    if ( forward6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward6_oid, OID_LENGTH(forward6_oid),
            ASN_OCTET_STR,
            (u_char *)forward6_ptr, strlen(forward6_ptr) ) ;
    }
    if ( forward7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward7_oid, OID_LENGTH(forward7_oid),
            ASN_OCTET_STR,
            (u_char *)forward7_ptr, strlen(forward7_ptr) ) ;
    }
    if ( forward8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            forward8_oid, OID_LENGTH(forward8_oid),
            ASN_OCTET_STR,
            (u_char *)forward8_ptr, strlen(forward8_ptr) ) ;
    }
    }}}
    if ( busyForward1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward1_oid, OID_LENGTH(busyForward1_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward1_ptr, strlen(busyForward1_ptr) ) ;
    }
    if ( no_of_ports > 1 )
    {
    if ( busyForward2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward2_oid, OID_LENGTH(busyForward2_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward2_ptr, strlen(busyForward2_ptr) ) ;
    }
    if ( no_of_ports > 2 )
    {
    if ( busyForward3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward3_oid, OID_LENGTH(busyForward3_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward3_ptr, strlen(busyForward3_ptr) ) ;
    }
    if ( busyForward4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward4_oid, OID_LENGTH(busyForward4_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward4_ptr, strlen(busyForward4_ptr) ) ;
    }
    if ( no_of_ports > 4 )
    {
    if ( busyForward5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward5_oid, OID_LENGTH(busyForward5_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward5_ptr, strlen(busyForward5_ptr) ) ;
    }
    if ( busyForward6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward6_oid, OID_LENGTH(busyForward6_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward6_ptr, strlen(busyForward6_ptr) ) ;
    }
    if ( busyForward7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward7_oid, OID_LENGTH(busyForward7_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward7_ptr, strlen(busyForward7_ptr) ) ;
    }
    if ( busyForward8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            busyForward8_oid, OID_LENGTH(busyForward8_oid),
            ASN_OCTET_STR,
            (u_char *)busyForward8_ptr, strlen(busyForward8_ptr) ) ;
    }
    }}}
    if ( delayedForward1_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward1_oid, OID_LENGTH(delayedForward1_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward1_ptr, strlen(delayedForward1_ptr) ) ;
    }
    if( no_of_ports > 1 )
    {
    if ( delayedForward2_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward2_oid, OID_LENGTH(delayedForward2_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward2_ptr, strlen(delayedForward2_ptr) ) ;
    }
    if( no_of_ports > 2 )
    {
    if ( delayedForward3_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward3_oid, OID_LENGTH(delayedForward3_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward3_ptr, strlen(delayedForward3_ptr) ) ;
    }
    if ( delayedForward4_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward4_oid, OID_LENGTH(delayedForward4_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward4_ptr, strlen(delayedForward4_ptr) ) ;
    }
    if ( no_of_ports > 4 )
    {
    if ( delayedForward5_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward5_oid, OID_LENGTH(delayedForward5_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward5_ptr, strlen(delayedForward5_ptr) ) ;
    }
    if ( delayedForward6_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward6_oid, OID_LENGTH(delayedForward6_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward6_ptr, strlen(delayedForward6_ptr) ) ;
    }
    if ( delayedForward7_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward7_oid, OID_LENGTH(delayedForward7_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward7_ptr, strlen(delayedForward7_ptr) ) ;
    }
    if ( delayedForward8_ptr )
    {
        snmp_varlist_add_variable(&var_list,
            delayedForward8_oid, OID_LENGTH(delayedForward8_oid),
            ASN_OCTET_STR,
            (u_char *)delayedForward8_ptr, strlen(delayedForward8_ptr) ) ;
    }
    }}}

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    if ( 1 == v3trap )
        send_v3trap( var_list, NULL ) ;
    else
        send_v2trap( var_list ) ;
    snmp_free_varbind( var_list ) ;
}

int
handle_PartNo(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char PartNo_value[256] = { 0 } ;
    char *PartNo_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            PartNo_ptr = nvram_get_safe( "1397", PartNo_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( PartNo_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)PartNo_ptr, strlen(PartNo_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_PartNo\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus1_value[256] = { 0 } ;
    char *hookStatus1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus1_ptr = nvram_get_safe( "4901", hookStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus1_ptr, strlen(hookStatus1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus2_value[256] = { 0 } ;
    char *hookStatus2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus2_ptr = nvram_get_safe( "4902", hookStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus2_ptr, strlen(hookStatus2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus3_value[256] = { 0 } ;
    char *hookStatus3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus3_ptr = nvram_get_safe( "4903", hookStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus3_ptr, strlen(hookStatus3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus4_value[256] = { 0 } ;
    char *hookStatus4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus4_ptr = nvram_get_safe( "4904", hookStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus4_ptr, strlen(hookStatus4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus5_value[256] = { 0 } ;
    char *hookStatus5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus5_ptr = nvram_get_safe( "4905", hookStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus5_ptr, strlen(hookStatus5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus6_value[256] = { 0 } ;
    char *hookStatus6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus6_ptr = nvram_get_safe( "4906", hookStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus6_ptr, strlen(hookStatus6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus7_value[256] = { 0 } ;
    char *hookStatus7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus7_ptr = nvram_get_safe( "4907", hookStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus7_ptr, strlen(hookStatus7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_hookStatus8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char hookStatus8_value[256] = { 0 } ;
    char *hookStatus8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            hookStatus8_ptr = nvram_get_safe( "4908", hookStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( hookStatus8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)hookStatus8_ptr, strlen(hookStatus8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_hookStatus8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus1_value[256] = { 0 } ;
    char *regStatus1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus1_ptr = nvram_get_safe( "4921", regStatus1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus1_ptr, strlen(regStatus1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus2_value[256] = { 0 } ;
    char *regStatus2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus2_ptr = nvram_get_safe( "4922", regStatus2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus2_ptr, strlen(regStatus2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus3_value[256] = { 0 } ;
    char *regStatus3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus3_ptr = nvram_get_safe( "4923", regStatus3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus3_ptr, strlen(regStatus3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus4_value[256] = { 0 } ;
    char *regStatus4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus4_ptr = nvram_get_safe( "4924", regStatus4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus4_ptr, strlen(regStatus4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus5_value[256] = { 0 } ;
    char *regStatus5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus5_ptr = nvram_get_safe( "4925", regStatus5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus5_ptr, strlen(regStatus5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus6_value[256] = { 0 } ;
    char *regStatus6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus6_ptr = nvram_get_safe( "4926", regStatus6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus6_ptr, strlen(regStatus6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus7_value[256] = { 0 } ;
    char *regStatus7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus7_ptr = nvram_get_safe( "4927", regStatus7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus7_ptr, strlen(regStatus7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_regStatus8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char regStatus8_value[256] = { 0 } ;
    char *regStatus8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            regStatus8_ptr = nvram_get_safe( "4928", regStatus8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( regStatus8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)regStatus8_ptr, strlen(regStatus8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_regStatus8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd1_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd1_value = get_nvram_long( "dnd_0", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd1_value, sizeof(dnd1_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd2_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd2_value = get_nvram_long( "dnd_1", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd2_value, sizeof(dnd2_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd3_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd3_value = get_nvram_long( "dnd_2", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd3_value, sizeof(dnd3_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd4_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd4_value = get_nvram_long( "dnd_3", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd4_value, sizeof(dnd4_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd5_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd5_value = get_nvram_long( "dnd_4", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd5_value, sizeof(dnd5_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd6_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd6_value = get_nvram_long( "dnd_5", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd6_value, sizeof(dnd6_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd7_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd7_value = get_nvram_long( "dnd_6", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd7_value, sizeof(dnd7_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_dnd8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long dnd8_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            dnd8_value = get_nvram_long( "dnd_7", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&dnd8_value, sizeof(dnd8_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_dnd8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward1_value[256] = { 0 } ;
    char *forward1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward1_ptr = nvram_get_safe( "forward_0", forward1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward1_ptr, strlen(forward1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward2_value[256] = { 0 } ;
    char *forward2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward2_ptr = nvram_get_safe( "forward_1", forward2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward2_ptr, strlen(forward2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward3_value[256] = { 0 } ;
    char *forward3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward3_ptr = nvram_get_safe( "forward_2", forward3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward3_ptr, strlen(forward3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward4_value[256] = { 0 } ;
    char *forward4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward4_ptr = nvram_get_safe( "forward_3", forward4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward4_ptr, strlen(forward4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward5_value[256] = { 0 } ;
    char *forward5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward5_ptr = nvram_get_safe( "forward_4", forward5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward5_ptr, strlen(forward5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward6_value[256] = { 0 } ;
    char *forward6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward6_ptr = nvram_get_safe( "forward_5", forward6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward6_ptr, strlen(forward6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward7_value[256] = { 0 } ;
    char *forward7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward7_ptr = nvram_get_safe( "forward_6", forward7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward7_ptr, strlen(forward7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_forward8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char forward8_value[256] = { 0 } ;
    char *forward8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            forward8_ptr = nvram_get_safe( "forward_7", forward8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( forward8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)forward8_ptr, strlen(forward8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_forward8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward1_value[256] = { 0 } ;
    char *busyForward1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward1_ptr = nvram_get_safe( "busyForward_0", busyForward1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward1_ptr, strlen(busyForward1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward2_value[256] = { 0 } ;
    char *busyForward2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward2_ptr = nvram_get_safe( "busyForward_1", busyForward2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward2_ptr, strlen(busyForward2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward3_value[256] = { 0 } ;
    char *busyForward3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward3_ptr = nvram_get_safe( "busyForward_2", busyForward3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward3_ptr, strlen(busyForward3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward4_value[256] = { 0 } ;
    char *busyForward4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward4_ptr = nvram_get_safe( "busyForward_3", busyForward4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward4_ptr, strlen(busyForward4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward5_value[256] = { 0 } ;
    char *busyForward5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward5_ptr = nvram_get_safe( "busyForward_4", busyForward5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward5_ptr, strlen(busyForward5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward6_value[256] = { 0 } ;
    char *busyForward6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward6_ptr = nvram_get_safe( "busyForward_5", busyForward6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward6_ptr, strlen(busyForward6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward7_value[256] = { 0 } ;
    char *busyForward7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward7_ptr = nvram_get_safe( "busyForward_6", busyForward7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward7_ptr, strlen(busyForward7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_busyForward8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char busyForward8_value[256] = { 0 } ;
    char *busyForward8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            busyForward8_ptr = nvram_get_safe( "busyForward_7", busyForward8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( busyForward8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)busyForward8_ptr, strlen(busyForward8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_busyForward8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward1_value[256] = { 0 } ;
    char *delayedForward1_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward1_ptr = nvram_get_safe( "delayedForward_0", delayedForward1_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward1_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward1_ptr, strlen(delayedForward1_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward2_value[256] = { 0 } ;
    char *delayedForward2_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward2_ptr = nvram_get_safe( "delayedForward_1", delayedForward2_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward2_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward2_ptr, strlen(delayedForward2_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward3(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward3_value[256] = { 0 } ;
    char *delayedForward3_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward3_ptr = nvram_get_safe( "delayedForward_2", delayedForward3_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward3_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward3_ptr, strlen(delayedForward3_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward3\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward4(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward4_value[256] = { 0 } ;
    char *delayedForward4_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward4_ptr = nvram_get_safe( "delayedForward_3", delayedForward4_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward4_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward4_ptr, strlen(delayedForward4_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward4\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward5(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward5_value[256] = { 0 } ;
    char *delayedForward5_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward5_ptr = nvram_get_safe( "delayedForward_4", delayedForward5_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward5_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward5_ptr, strlen(delayedForward5_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward5\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward6(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward6_value[256] = { 0 } ;
    char *delayedForward6_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward6_ptr = nvram_get_safe( "delayedForward_5", delayedForward6_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward6_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward6_ptr, strlen(delayedForward6_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward6\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward7(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward7_value[256] = { 0 } ;
    char *delayedForward7_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward7_ptr = nvram_get_safe( "delayedForward_6", delayedForward7_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward7_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward7_ptr, strlen(delayedForward7_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward7\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_delayedForward8(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char delayedForward8_value[256] = { 0 } ;
    char *delayedForward8_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            delayedForward8_ptr = nvram_get_safe( "delayedForward_7", delayedForward8_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( delayedForward8_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)delayedForward8_ptr, strlen(delayedForward8_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_delayedForward8\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionBoot(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char versionBoot_value[256] = { 0 } ;
    char *versionBoot_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionBoot_ptr = nvram_get_safe( "69", versionBoot_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionBoot_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionBoot_ptr, strlen(versionBoot_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionBoot\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionCore(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char versionCore_value[256] = { 0 } ;
    char *versionCore_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionCore_ptr = nvram_get_safe( "70", versionCore_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionCore_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionCore_ptr, strlen(versionCore_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionCore\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionBase(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char versionBase_value[256] = { 0 } ;
    char *versionBase_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionBase_ptr = nvram_get_safe( "45", versionBase_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionBase_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionBase_ptr, strlen(versionBase_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionBase\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_versionProg(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    char versionProg_value[256] = { 0 } ;
    char *versionProg_ptr = NULL ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            versionProg_ptr = nvram_get_safe( "68", versionProg_value, 256 ) ; /* CHECK pvalue or FILL in */

            if ( versionProg_ptr )
            {
                snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)versionProg_ptr, strlen(versionProg_ptr));
            }

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_versionProg\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_networkMode(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long networkMode_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            networkMode_value = get_nvram_long( "8", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&networkMode_value, sizeof(networkMode_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_networkMode\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_pppoeLink(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long pppoeLink_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            pppoeLink_value = get_nvram_long( "211", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&pppoeLink_value, sizeof(pppoeLink_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_pppoeLink\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_natTraversal1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long natTraversal1_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            natTraversal1_value = get_nvram_long( "52", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&natTraversal1_value, sizeof(natTraversal1_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_natTraversal1\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
int
handle_natTraversal2(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{

    int pvalue_empty =  0 ;

    long natTraversal2_value = 0 ;

    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */

    switch(reqinfo->mode) {

        case MODE_GET:
            pvalue_empty = 0 ;
            natTraversal2_value = get_nvram_long( "730", &pvalue_empty ) ;/* CHECK pvalue or FILL in */

            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                (u_char *)&natTraversal2_value, sizeof(natTraversal2_value) ) ;

            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_natTraversal2\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
