#!/bin/bash

CDIR=`pwd`

CORES=$((2*$(cat /proc/cpuinfo | grep -c processor)))

. /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

COPYTO="`pwd`/../../../../ht/image_build/image_source/prog/snmp"

echo "netsnmp_cv_func_pci_lookup_name_LMIBLIBS=false" >config.cache
if [ "$1" = "-configure" ] || [ ! -f Makefile ];then
	LIBS='-lnvram -lpvalue_validation' \
	LDFLAGS="${LDFLAGS} -L${CDIR}/../../../../ht/image_build/image_source/base/usr/lib" \
	./configure \
		${CONFIGURE_FLAGS} \
                --cache-file=config.cache \
		--prefix="/" \
		--with-mibdirs="/etc/mibdir" \
		--with-sys-contact="noone@nowhe.re" \
		--with-sys-location="HT8xx" \
		--with-logfile="/tmp/snmpd.log" \
		--with-persistent-directory="/var/net-snmp" \
		--with-default-snmp-version="2" \
		--disable-embedded-perl \
		--disable-manuals \
		--enable-applications \
		--disable-scripts \
		--disable-debugging \
		--disable-deprecated \
		--enable-developer \
		--enable-ipv6 \
		--enable-mini-agent \
		--with-mib-modules="grandstream" #--enable-notify-only --enable-no-listen 
fi

make clean
make V=99 -j${CORES} agent
make V=99 -j${CORES} apps
ls -l snmplib/.libs/libnetsnmp*so*
ls -l agent/.libs/libnetsnmp*so*
ls -l agent/.libs/snmpd

cp -rfP snmplib/.libs/libnetsnmp*so* ${COPYTO}/lib
cp -rfP agent/.libs/libnetsnmp*so* ${COPYTO}/lib
cp agent/.libs/snmpd ${COPYTO}/bin
