#!/bin/bash

CDIR=`pwd`

BUILD_OUT=$CDIR/build_out
RELEASE_DIR=../../../../ht/image_build/image_source/base/usr/bin

. /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi

touch `find ./ -name "*.texi"`

echo ac_cv_lib_intl_gettext=no >cache.conf
echo ac_cv_func_getaddrinfo=no >>cache.conf
if [ ! -f Makefile ];then
	./bootstrap
	./configure \
		--cache-file=cache.conf \
		--build=i686-pc-linux \
		--host=arm-linux \
		--prefix=$BUILD_OUT --exec-prefix=$BUILD_OUT \
		--enable-ipv6 \
		--with-yielding-select=no \
		--disable-main \
		--disable-nls \
		--without-sntp \
		--enable-shared \
		--enable-static 
fi

if [ -r $BUILD_OUT ];then
	rm -r $BUILD_OUT
fi

#make clean 
make clean && make && make install

# release to image build dir
cp -v ${BUILD_OUT}/bin/ntpdate ${RELEASE_DIR}
