#!/bin/bash

PWD=`pwd`
CACHEFILE="arm-linux.cache"
LIBDIR="${PWD}/../../../../ht/image_build/image_source/base/usr/lib"
LZOLIBDIR=${PWD}/../lzo-2.10
LZ4LIBDIR=${PWD}/../lz4-1.9.3
NVRAM_INC="${PWD}/../../../../ht/system/nvtool"
NVRAM_LIBS="-lnvram  -lpvalue_validation"

source /opt/dspg/v2.3.0-rc2/environment-setup-cortexa9-neon-dspg-linux-gnueabi
if [ "$1" = "configure" ];then
autoreconf --force --install
LZ4_CFLAGS="-I${LZ4LIBDIR}/lib " \
LZ4_LIBS="-L${LIBDIR} -llz4 " \
LZO_CFLAGS="-I${LZOLIBDIR}/include " \
LZO_LIBS="-L${LIBDIR} -llzo2 " \
CFLAGS="${CFLAGS} -I${NVRAM_INC} " \
LIBS="${LIBS} -L${LIBDIR} ${NVRAM_LIBS}" \
./configure ${CONFIGURE_FLAGS} \
            --disable-plugin-auth-pam \
            --enable-password-save \
            --prefix=${PWD}/.install
fi

mkdir .install

make clean && make
#${STRIP} src/openvpn/openvpn
make install
