#ifndef __SBOOT_H__
#define __SBOOT_H__

/* sboot_verify_kernel:
 *
 * addr = image header address
 *
 * returns 0 on success, !0 on error
 */
int sboot_verify_kernel(unsigned long *addr);

/* (cb) = (mb)^(el) mod (nb) */
int expmod(unsigned char cb[256], uint8_t *mb, unsigned int mlen,
	   unsigned long el, uint8_t *nb, unsigned int nlen);
int sboot_is_dev_secured(void);
unsigned long sboot_check_hdr(void *hdr);
unsigned long sboot_check_img(unsigned char *img, size_t imglen,
			      unsigned char expected_sha[32]);

#endif /* __SBOOT_H__ */

