#ifndef __DVF101_CLOCK_REGS_H
#define __DVF101_CLOCK_REGS_H

#define GCU_RST_CTRL		0x0000
#define GCU_SW_RST		0x0004
#define GCU_WARM_RST		0x0008
#define GCU_OSC_CTRL		0x000C
#define PLL_REG_BASE		0x1000
#define PLL_OFFSET_STEP		0x0014
#define PLL_BASE(x)		((x - 1) * PLL_OFFSET_STEP + PLL_REG_BASE)
#define PLL_UNIT_CTRL		0x0000
#define PLL_UNIT_RST_CNT	0x0004
#define PLL_UNIT_LOCK_CNT	0x0008
#define PLL_CFG1		0x000C
#define PLL_CFG2		0x0010
#define GCU_MCU_CTRL		0x2000
#define GCU_MCU_DIV_VAL		0x2004
#define GCU_MCU_AXI_DIV_VAL	0x2008
#define GCU_CSS_CTRL		0x200C
#define GCU_CSS_DIV_VAL		0x2010
#define GCU_TDM1_CTRL		0x2014
#define GCU_TDM1_DIV_VAL	0x2018
#define GCU_TDM2_CTRL		0x201C
#define GCU_TDM2_DIV_VAL	0x2020
#define GCU_TDM3_CTRL		0x2024
#define GCU_TDM3_DIV_VAL	0x2028
#define GCU_UART1_CTRL		0x202C
#define GCU_UART2_CTRL		0x2030
#define GCU_UART3_CTRL		0x2034
#define GCU_UART4_CTRL		0x2038
#define GCU_NFC_CTRL		0x203C
#define GCU_BMP_CTRL		0x2040
#define GCU_BMP_DIV_VAL		0x2044
#define GCU_CS_CTRL		0x2048
#define GCU_CS_DIV_VAL		0x204C
#define GCU_DCLS_CTRL		0x2050
#define GCU_DCLS_DIV_VAL	0x2054
#define GCU_DAIF_CTRL		0x2058
#define GCU_LCDC_CTRL		0x205C
#define GCU_LCDC_DIV_VAL	0x2060
#define GCU_PWM_GEN_CTRL	0x2064
#define GCU_CRYPTO_CTRL		0x2068
#define GCU_MCU_GDMAC_CTRL	0x206C
#define GCU_CSS_GDMAC_CTRL	0x2070
#define GCU_SEC_CTRL		0x2074
#define GCU_SPI1_CTRL		0x2078
#define GCU_SPI1_DIV_VAL	0x207C
#define GCU_SPI2_CTRL		0x2080
#define GCU_SPI3_CTRL		0x2088
#define GCU_SPI3_DIV_VAL	0x208C
#define GCU_I2C1_CTRL		0x2090
#define GCU_I2C2_CTRL		0x2094
#define GCU_GPIO_CTRL		0x2098
#define GCU_RTC_CTRL		0x209C
#define GCU_RTC_DIV_VAL		0x20A0
#define GCU_WD_CTRL		0x20A4
#define GCU_WD_DIV_VAL		0x20A8
#define GCU_DRT_CTRL		0x20AC
#define GCU_ADPCM_CTRL		0x20B0
#define GCU_ADPCM_DIV_VAL	0x20B4
#define GCU_REFDIV_CTRL		0x20B8
#define GCU_REFDIV_DIV_VAL	0x20BC
#define GCU_MCU_TIMER12_CTRL	0x20C0
#define GCU_MCU_TIMER34_CTRL	0x20C4
#define GCU_CSS_TIMER12_CTRL	0x20C8
#define GCU_APU_CTRL		0x20CC
#define GCU_APU_DIV_VAL		0x20D0
#define GCU_CCU_CTRL		0x20D4
#define GCU_GPU_CTRL		0x20D8
#define GCU_GPU_DIV_VAL		0x20DC
#define GCU_ETH_CTRL		0x20E0
#define GCU_ETH_DIV_VAL		0x20E4
#define GCU_DDR3_CTRL		0x20E8
#define GCU_SDIO_CTRL		0x20EC
#define GCU_SDIO_DIV_VAL	0x20F0
#define GCU_EMMC_CTRL		0x20F4
#define GCU_EMMC_DIV_VAL	0x20F8
#define GCU_CLK_OUT_CTRL	0x20FC
#define GCU_CLK_OUT_DIV_VAL	0x2100
#define GCU_DSI_CTRL		0x2104
#define GCU_DSI_DIV_VAL		0x2108
#define GCU_USB_PHY_CTRL	0x210C
#define GCU_USB_PHY_DIV_VAL	0x2110
#define GCU_USB_OTG_CTRL	0x2114
#define GCU_USB_HOST_CTRL	0x2118

/* reg, shift (enable bits have fixed length 1) */
#define PLL1_PRE_DIV_EN			(PLL_BASE(1) + PLL_UNIT_CTRL), 0
#define PLL2_PRE_DIV_EN			(PLL_BASE(2) + PLL_UNIT_CTRL), 0
#define PLL3_PRE_DIV_EN			(PLL_BASE(3) + PLL_UNIT_CTRL), 0
#define PLL1_POST_DIV_EN		(PLL_BASE(1) + PLL_UNIT_CTRL), 1
#define PLL2_POST_DIV_EN		(PLL_BASE(2) + PLL_UNIT_CTRL), 1
#define PLL3_POST_DIV_EN		(PLL_BASE(3) + PLL_UNIT_CTRL), 1
#define PLL1_PRE_DIV_EN_STAT		(PLL_BASE(1) + PLL_UNIT_CTRL), 14
#define PLL2_PRE_DIV_EN_STAT		(PLL_BASE(2) + PLL_UNIT_CTRL), 14
#define PLL3_PRE_DIV_EN_STAT		(PLL_BASE(3) + PLL_UNIT_CTRL), 14
#define PLL1_POST_DIV_EN_STAT		(PLL_BASE(1) + PLL_UNIT_CTRL), 15
#define PLL2_POST_DIV_EN_STAT		(PLL_BASE(2) + PLL_UNIT_CTRL), 15
#define PLL3_POST_DIV_EN_STAT		(PLL_BASE(3) + PLL_UNIT_CTRL), 15
#define CLK_OUT_DIV_CLK_EN		GCU_CLK_OUT_CTRL,	6
#define CLK_OUT_DIV_EN_STAT		GCU_CLK_OUT_CTRL,	7
#define BMP_DIV_CLK_EN			GCU_BMP_CTRL,		6
#define BMP_DIV_EN_STAT			GCU_BMP_CTRL,		7
#define CS_DIV_CLK_EN			GCU_CS_CTRL,		6
#define CS_DIV_EN_STAT			GCU_CS_CTRL,		7
#define AXI_DDR_CLK_EN			GCU_MCU_CTRL,		4
#define AXI_SYS_CLK_EN			GCU_MCU_CTRL,		5
#define MCU_MAIN_DIV_EN_STAT		GCU_MCU_CTRL,		17
#define MCU_AXI_DDR_DIV_EN_STAT		GCU_MCU_CTRL,		20
#define MCU_AXI_SYS_DIV_EN_STAT		GCU_MCU_CTRL,		21
#define MCU_AXI_DDR_CLK_EN		GCU_MCU_CTRL,		4
#define MCU_ROM_CLK_EN			GCU_MCU_CTRL,		11
#define RTC_DIV_CLK_EN			GCU_RTC_CTRL,		6
#define RTC_DIV_EN_STAT			GCU_RTC_CTRL,		7
#define WD_DIV_CLK_EN			GCU_WD_CTRL,		6
#define WD_DIV_EN_STAT			GCU_WD_CTRL,		7
#define APU_DIV_CLK_EN			GCU_APU_CTRL,		6
#define APU_DIV_EN_STAT			GCU_APU_CTRL,		7
#define DCLS_DIV_CLK_EN			GCU_DCLS_CTRL,		6
#define DCLS_DIV_EN_STAT		GCU_DCLS_CTRL,		7
#define TDM1_DIV_CLK_EN			GCU_TDM1_CTRL,		6
#define TDM1_DIV_EN_STAT		GCU_TDM1_CTRL,		7
#define TDM2_DIV_CLK_EN			GCU_TDM2_CTRL,		6
#define TDM2_DIV_EN_STAT		GCU_TDM2_CTRL,		7
#define TDM3_DIV_CLK_EN			GCU_TDM3_CTRL,		6
#define TDM3_DIV_EN_STAT		GCU_TDM3_CTRL,		7
#define CSS_MAIN_DIV_EN_STAT		GCU_CSS_CTRL,		17
#define CSS_MAIN_CLK_EN			GCU_CSS_CTRL,		1
#define ADPCM_DIV_EN_STAT		GCU_ADPCM_CTRL,		7
#define ADPCM_DIV_CLK_EN		GCU_ADPCM_CTRL,		6
#define APU_RIPPLE_DIV_EN		GCU_APU_CTRL,		11
#define DSI_REF_CLK_EN			GCU_DSI_CTRL,		10
#define DSI_CFG_CLK_EN			GCU_DSI_CTRL,		11
#define USB_PHY_DIV_CLK_EN		GCU_USB_PHY_CTRL,	6
#define USB_PHY_DIV_EN_STAT		GCU_USB_PHY_CTRL,	7
#define SDIO_MAIN_CLK_EN		GCU_SDIO_CTRL,		6
#define SDIO_MAIN_DIV_EN_STAT		GCU_SDIO_CTRL,		7
#define EMMC_MAIN_CLK_EN		GCU_EMMC_CTRL,		6
#define EMMC_MAIN_DIV_EN_STAT		GCU_EMMC_CTRL,		7
#define REFDIV_DIV_CLK_EN		GCU_REFDIV_CTRL,	6
#define REFDIV_DIV_EN_STAT		GCU_REFDIV_CTRL,	7
#define ETH_MAIN_CLK_EN			GCU_ETH_CTRL,		6
#define ETH_CORE_CLK_EN			GCU_ETH_CTRL,		19
#define ETH_MAIN_DIV_EN_STAT		GCU_ETH_CTRL,		7
#define GPU_DIV_CLK_EN			GCU_GPU_CTRL,		6
#define GPU_DIV_EN_STAT			GCU_GPU_CTRL,		7
#define LCDC_DIV_CLK_EN			GCU_LCDC_CTRL,		6
#define LCDC_DIV_EN_STAT		GCU_LCDC_CTRL,		7
#define DSI_CLK_EN			GCU_DSI_CTRL,		6
#define SPI1_DIV_CLK_EN			GCU_SPI1_CTRL,		6
#define SPI3_DIV_CLK_EN			GCU_SPI3_CTRL,		6
#define SPI1_DIV_EN_STAT		GCU_SPI1_CTRL,		7
#define SPI3_DIV_EN_STAT		GCU_SPI3_CTRL,		7
#define TDM1_APB_CLK_EN			GCU_TDM1_CTRL,		4
#define TDM2_APB_CLK_EN			GCU_TDM2_CTRL,		4
#define TDM3_APB_CLK_EN			GCU_TDM3_CTRL,		4
#define UART1_APB_CLK_EN		GCU_UART1_CTRL,		4
#define UART2_APB_CLK_EN		GCU_UART2_CTRL,		4
#define UART3_APB_CLK_EN		GCU_UART3_CTRL,		4
#define UART4_APB_CLK_EN		GCU_UART4_CTRL,		4
#define NFC_APB_CLK_EN			GCU_NFC_CTRL,		4
#define CS_APB_CLK_EN			GCU_CS_CTRL,		4
#define DAIF_APB_CLK_EN			GCU_DAIF_CTRL,		4
#define CRYPTO_APB_CLK_EN		GCU_CRYPTO_CTRL,	4
#define MCU_GDMAC_APB_CLK_EN		GCU_MCU_GDMAC_CTRL,	4
#define CSS_GDMAC_APB_CLK_EN		GCU_CSS_GDMAC_CTRL,	4
#define SPI2_APB_CLK_EN			GCU_SPI2_CTRL,		4
#define I2C1_APB_CLK_EN			GCU_I2C1_CTRL,		4
#define I2C2_APB_CLK_EN			GCU_I2C2_CTRL,		4
#define GPIO_APB_CLK_EN			GCU_GPIO_CTRL,		4
#define RTC_APB_CLK_EN			GCU_RTC_CTRL,		4
#define WD_APB_CLK_EN			GCU_WD_CTRL,		4
#define MCU_TIMER12_APB_CLK_EN		GCU_MCU_TIMER12_CTRL,	4
#define MCU_TIMER34_APB_CLK_EN		GCU_MCU_TIMER34_CTRL,	4
#define CSS_TIMER12_APB_CLK_EN		GCU_CSS_TIMER12_CTRL,	4
#define CSS_TIMER34_APB_CLK_EN		GCU_CSS_TIMER34_CTRL,	4
#define CCU_APB_CLK_EN			GCU_CCU_CTRL,		4
//#define DDR3_CTRL_APB_CLK_EN
//#define DDR3_PHY_APB_CLK_EN
#define DSI_APB_CLK_EN			GCU_DSI_CTRL,		4
#define CSS_AHB_DIV_EN_STAT		GCU_CSS_CTRL,		22
#define CSS_AHB_CLK_EN			GCU_CSS_CTRL,		6
#define NFC_AHB_CLK_EN			GCU_NFC_CTRL,		5
#define BMP_AHB_CLK_EN			GCU_BMP_CTRL,		5
#define DCLS_AHB_CLK_EN			GCU_DCLS_CTRL,		5
#define PWM_GEN_AHB_CLK_EN		GCU_PWM_GEN_CTRL,	4
#define CRYPTO_AHB_CLK_EN		GCU_CRYPTO_CTRL,	5
#define MCU_GDMAC_AHB_CLK_EN		GCU_MCU_GDMAC_CTRL,	5
#define CSS_GDMAC_AHB_CLK_EN		GCU_CSS_GDMAC_CTRL,	5
#define SEC_AHB_CLK_EN			GCU_SEC_CTRL,		5
#define DRT_AHB_CLK_EN			GCU_DRT_CTRL,		5
#define ADPCM_AHB_CLK_EN		GCU_ADPCM_CTRL,		5
#define CCU_AHB_CLK_EN			GCU_CCU_CTRL,		5
#define SDIO_AHB_CLK_EN			GCU_SDIO_CTRL,		5
#define EMMC_AHB_CLK_EN			GCU_EMMC_CTRL,		5
#define USB_OTG_AHB_CLK_EN		GCU_USB_OTG_CTRL,	5
#define USB_HOST_OHCI_AHB_CLK_EN	GCU_USB_HOST_CTRL,	7
#define USB_HOST_EHCI_AHB_CLK_EN	GCU_USB_HOST_CTRL,	6

/* reg, shift (muxes have fixed length 2) */
#define PLL1_CLK_SEL		(PLL_BASE(1) + PLL_UNIT_CTRL),  4
#define PLL2_CLK_SEL		(PLL_BASE(2) + PLL_UNIT_CTRL),  4
#define PLL3_CLK_SEL		(PLL_BASE(3) + PLL_UNIT_CTRL),  4
#define PLL1_CLK_IN_USE		(PLL_BASE(1) + PLL_UNIT_CTRL),  7
#define PLL2_CLK_IN_USE		(PLL_BASE(2) + PLL_UNIT_CTRL),  7
#define PLL3_CLK_IN_USE		(PLL_BASE(3) + PLL_UNIT_CTRL),  7
#define PLL1_INPUT_SEL		(PLL_BASE(1) + PLL_UNIT_CTRL),  8
#define PLL1_BYPASS_SEL		(PLL_BASE(1) + PLL_UNIT_CTRL), 10
#define PLL2_INPUT_SEL		(PLL_BASE(1) + PLL_UNIT_CTRL),  8
#define PLL2_BYPASS_SEL		(PLL_BASE(2) + PLL_UNIT_CTRL), 10
#define PLL3_INPUT_SEL		(PLL_BASE(3) + PLL_UNIT_CTRL),  8
#define PLL3_BYPASS_SEL		(PLL_BASE(3) + PLL_UNIT_CTRL), 10
#define PLL3_EXT_INPUT_SEL	(PLL_BASE(3) + PLL_UNIT_CTRL), 12
#define BMP_INPUT_SEL		GCU_BMP_CTRL,     8
#define CSS_INPUT_SEL		GCU_CSS_CTRL,     8
#define TDM1_INPUT_SEL		GCU_TDM1_CTRL,    8
#define TDM2_INPUT_SEL		GCU_TDM2_CTRL,    8
#define TDM3_INPUT_SEL		GCU_TDM3_CTRL,    8
#define DCLS_INPUT_SEL		GCU_DCLS_CTRL,    8
#define LCDC_INPUT_SEL		GCU_LCDC_CTRL,    8
#define SPI1_INPUT_SEL		GCU_SPI1_CTRL,    8
#define SPI2_INPUT_SEL		GCU_SPI2_CTRL,    8
#define SPI3_INPUT_SEL		GCU_SPI3_CTRL,    8
#define RTC_INPUT_SEL		GCU_RTC_CTRL,     8
#define WD_INPUT_SEL		GCU_WD_CTRL,      8
#define REFDIV_INPUT_SEL	GCU_REFDIV_CTRL,  8
#define APU_CLK_SEL		GCU_APU_CTRL,    10
#define APU_DIV_INPUT_SEL	GCU_APU_CTRL,     8
#define GPU_INPUT_SEL		GCU_GPU_CTRL,     8
#define ETH_INPUT_SEL		GCU_ETH_CTRL,     8
#define ETH_INT_DIV_SRC_SEL	GCU_ETH_CTRL,    10
#define ETH_TX_CLK_SEL		GCU_ETH_CTRL,    16
#define ETH_RX_CLK_SEL		GCU_ETH_CTRL,    17
#define ETH_TX_PAD_SRC_SEL	GCU_ETH_CTRL,    18
#define SDIO_INPUT_SEL		GCU_SDIO_CTRL,    8
#define EMMC_INPUT_SEL		GCU_EMMC_CTRL,    8
#define USB_PHY_INPUT_SEL	GCU_USB_PHY_CTRL, 8
#define CLK_OUT_INPUT_SEL	GCU_CLK_OUT_CTRL, 8

/* reg, shift, length */
#define PLL1_PRE_DIV_VAL	(PLL_BASE(1) + PLL_UNIT_CTRL), 16, 2
#define PLL2_PRE_DIV_VAL	(PLL_BASE(2) + PLL_UNIT_CTRL), 16, 2
#define PLL3_PRE_DIV_VAL	(PLL_BASE(3) + PLL_UNIT_CTRL), 16, 2
#define PLL1_POST_DIV_VAL	(PLL_BASE(1) + PLL_UNIT_CTRL), 24, 6
#define PLL2_POST_DIV_VAL	(PLL_BASE(2) + PLL_UNIT_CTRL), 24, 6
#define PLL3_POST_DIV_VAL	(PLL_BASE(3) + PLL_UNIT_CTRL), 24, 6
#define CLK_OUT_DIV_VAL		GCU_CLK_OUT_DIV_VAL,  0,  8
#define BMP_DIV_VAL		GCU_BMP_DIV_VAL,      0,  4
#define CS_DIV_VAL		GCU_CS_DIV_VAL,       0,  8
#define MCU_MAIN_DIV_VAL	GCU_MCU_DIV_VAL,      0,  4
#define MCU_AXI_DDR_DIV_VAL	GCU_MCU_AXI_DIV_VAL,  8,  2
#define MCU_AXI_SYS_DIV_VAL	GCU_MCU_AXI_DIV_VAL, 12,  6
#define RTC_DIV_VAL		GCU_RTC_DIV_VAL,      0, 11
#define WD_DIV_VAL		GCU_WD_DIV_VAL,       0, 11
#define APU_DIV_VAL		GCU_APU_DIV_VAL,      0,  8
#define DCLS_DIV_VAL		GCU_DCLS_DIV_VAL,     0,  8
#define TDM1_DIV_VAL		GCU_TDM1_DIV_VAL,     0, 13
#define TDM2_DIV_VAL		GCU_TDM2_DIV_VAL,     0, 13
#define TDM3_DIV_VAL		GCU_TDM3_DIV_VAL,     0, 13
#define CSS_MAIN_DIV_VAL	GCU_CSS_DIV_VAL,      0,  5
#define ADPCM_DIV_VAL		GCU_ADPCM_DIV_VAL,    0,  6
#define USB_PHY_DIV_VAL		GCU_USB_PHY_DIV_VAL,  0,  8
#define SDIO_INT_DIV_VAL	GCU_SDIO_DIV_VAL,    16,  4
#define SDIO_MAIN_DIV_VAL	GCU_SDIO_DIV_VAL,     0,  9
#define EMMC_INT_DIV_VAL	GCU_EMMC_DIV_VAL,    16,  4
#define EMMC_MAIN_DIV_VAL	GCU_EMMC_DIV_VAL,     0,  9
#define REFDIV_DIV_VAL		GCU_REFDIV_DIV_VAL,   0, 10
#define ETH_MAIN_DIV_VAL	GCU_ETH_DIV_VAL,      0,  9
#define ETH_INT_DIV_VAL		GCU_ETH_DIV_VAL,     24,  6
#define ETH_TX_CLK_PHASE_SEL	GCU_ETH_CTRL,        21,  3
#define GPU_DIV_VAL		GCU_GPU_DIV_VAL,      0,  4
#define LCDC_DIV_VAL		GCU_LCDC_DIV_VAL,     0, 10
#define SPI1_DIV_VAL		GCU_SPI1_DIV_VAL,     0,  8
#define SPI3_DIV_VAL		GCU_SPI3_DIV_VAL,     0,  8
#define CSS_AHB_DIV_VAL		GCU_CSS_DIV_VAL,      0,  3

#define PRECISION		3
static inline uint32_t
round_div(uint32_t a, uint32_t b)
{
	uint32_t tmp = (a << PRECISION) / b;
	return (tmp >> PRECISION) + ((tmp >> (PRECISION - 1)) & 1);
}

static inline unsigned long
floor_div(unsigned long a, unsigned long b)
{
	return (a + b - 1) / b;
}

#endif /* __DVF101_CLOCK_REGS_H */
