#ifndef DMW_CLOCK_H
#define DMW_CLOCK_H

void clk_init(void);
void clk_enable(char *id);
void clk_disable(char *id);
unsigned long clk_get_rate(const char *id);
int clk_set_rate(char *id, unsigned long rate);
int clk_reconfigure(int cpu_speed);

void reset_set(char *id);
void reset_release(char *id);

unsigned long dvf99_get_main_clk(void);
unsigned long dvf99_get_hclk(void);
unsigned long dvf99_get_cpufreq(void);
unsigned long dvf99_get_cssfreq(void);
unsigned long dvf99_get_dramfreq(void);

enum eth_mode {
	ETH_MII,
	ETH_MII_PHY,
	ETH_RMII,
	ETH_RMII_EXT,
	ETH_RGMII,

	NUM_ETH_MODES
};

enum eth_speed {
	ETH_SPEED_10,
	ETH_SPEED_100,
	ETH_SPEED_1000,

	NUM_ETH_SPEEDS,
};

uint32_t sdmmc_get_phase(int have_tx, int is_sd);
void sdmmc_set_phase(int have_tx, int is_sd, uint32_t phase);
int clk_eth_config(enum eth_mode mode, enum eth_speed speed);
void clk_enable_usb1(void);

#endif
