#ifndef __LINUX_MFD_DVF10A_H
#define __LINUX_MFD_DVF10A_H

#define DAIF_HW_REVISION	0
#define DAIF_PMUEN		1
#define DAIF_RXTUN		2
#define DAIF_CLKCTRL		3
#define DAIF_RAADC		4
#define DAIF_AFEDIGC1		5
#define DAIF_AFEDIGC2		6
#define DAIF_RAADOMSB		7
#define DAIF_RAADO		8
#define DAIF_AMPOUTTHD1		10
#define DAIF_AMPOUTTHD2		11
#define DAIF_RSSIO		12
#define DAIF_AFEAMPEN		14
#define DAIF_AFECFG1		15
#define DAIF_AFECFG2		16
#define DAIF_AFEIN1		17
#define DAIF_AFEOUTGC0		18
#define DAIF_AFEOUTGC1		19
#define DAIF_AFESIGC1		20
#define DAIF_AFESIGC2		21
#define DAIF_AMPOUTSEL1		22
#define DAIF_LQSD_CFG1		23
#define DAIF_LQSD_CFG2		24
#define DAIF_PORBGCFG		25
#define DAIF_PORCTL		26
#define DAIF_TEST_REG		28
#define DAIF_BASECTRL		29
#define DAIF_ICU_ANA_STAT_EN1	31
#define DAIF_ICU_INT_POL	32
#define DAIF_CMUAUXCLKDIV	33
#define DAIF_AMPOUTSEL2		34
#define DAIF_LQSD_MUX3		35
#define DAIF_LQSD_MUX1		36
#define DAIF_LQSD_MUX2		37
#define DAIF_DAC0GC0		38
#define DAIF_PWM0_CFG2		39
#define DAIF_DACMUTE		40
#define DAIF_CLKCTRL2		42
#define DAIF_AFEIN2		43
#define DAIF_AUXEN		44
#define DAIF_BMP_VEC		45
#define DAIF_PWM0_CRGTMRCFG2	46
#define DAIF_AUXADCFG		47
#define DAIF_CMPLVLCNT1		48
#define DAIF_PWM1_CFG2		49
#define DAIF_CMPLVLCNT2		51
#define DAIF_RFI2DPU		52
#define DAIF_RONOFF		53

#define DAIF_ANA_DATA_WR_LSB	65
#define DAIF_ANA_DATA_WR_MSB	66
#define DAIF_ANA_ADDR_WR	67
#define DAIF_ANA_ADDR_RD	68
#define DAIF_ANA_DATA_RD_LSB	69
#define DAIF_ANA_DATA_RD_MSB	70
#define DAIF_PWM0_DUTY		71
#define DAIF_PWM1_DUTY		72
#define DAIF_PWM0_CFG1		73
#define DAIF_PWM0_CFG3		74
#define DAIF_PWM0_CRGTMRCFG1	75
#define DAIF_AUXBGPROG		76
#define DAIF_PWM0_CRGTIMEOUT	77
#define DAIF_PWM1_CFG1		78
#define DAIF_PWM1_CFG3		79
#define DAIF_AFEMIC0_SHORT	81
#define DAIF_AFEMIC1_SHORT	82
#define DAIF_EFUSE		83
#define DAIF_AUXAMP		84
#define DAIF_RST_STAT		85
#define DAIF_LC1CFG1		86
#define DAIF_LC1CFG2		87
#define DAIF_LC2CFG1		88
#define DAIF_LC2CFG2		89
#define DAIF_DPUCTL1		91
#define DAIF_DPUCTL2		92
#define DAIF_DPUCTL3		93
#define DAIF_DPUCTL4		94
#define DAIF_DPUCTL5		95
#define DAIF_DPUCTL6		96
#define DAIF_DPUCTL7		97
#define DAIF_ICU_ANA_EN1	98
#define DAIF_ICU_PWR_EN		99
#define DAIF_ICU_ANA_EN2	100
#define DAIF_ICU_PWR_STAT	101
#define DAIF_ICU_PWR_RAW	102
#define DAIF_ICU_ANA_STAT1	103
#define DAIF_ICU_ANA_STAT2	104
#define DAIF_DCLS_ANA_CTRL	106
#define DAIF_ICU_ANA_RAW	107
#define DAIF_ICU_ANA_SRC1	108
#define DAIF_AUX_DCIN1CTRL	109
#define DAIF_AUX_DCIN2CTRL	110
#define DAIF_ICU_PWR_SRC	113
#define DAIF_ICU_PWR_STAT_EN	114

#define DAIF_INDIRECT_START	128 // offset to Analog reg 0

#define DAIF_APU_REG1		(DAIF_INDIRECT_START + 0*2)
#define DAIF_LED_CTRL		(DAIF_INDIRECT_START + 1*2)
#define DAIF_DCLASS_ANA_CFG	(DAIF_INDIRECT_START + 2*2)
#define DAIF_DCDC_ANA		(DAIF_INDIRECT_START + 3*2)
#define DAIF_AUX_PMTPCTL1	(DAIF_INDIRECT_START + 4*2)
#define DAIF_AUX_PMTPCTL2	(DAIF_INDIRECT_START + 5*2)
#define DAIF_TPDX		(DAIF_INDIRECT_START + 6*2)
#define DAIF_TPDY		(DAIF_INDIRECT_START + 7*2)
#define DAIF_TPDZ1		(DAIF_INDIRECT_START + 8*2)
#define DAIF_TPDZ2		(DAIF_INDIRECT_START + 9*2)
#define DAIF_AFEICTRL1		(DAIF_INDIRECT_START + 10*2)
#define DAIF_AFEICTRL2		(DAIF_INDIRECT_START + 11*2)

#define DAIF_INDIRECT_END	(DAIF_AFEICTRL2+2)

void dvf10a_init(void);
unsigned short daif_read(unsigned short reg);
void daif_write(unsigned short reg, unsigned short value);
unsigned short daif_read_via_rapu(unsigned short reg);
void daif_write_via_wapu(unsigned short reg, unsigned short value);
void apply_rxtun(void);

#endif /* __LINUX_MFD_DVF10A_H */
