/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <lcd.h>
#include <spi.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/lcd.h>
#include <asm/arch/clock.h>
#include <asm/arch/hardware.h>
#include <asm/arch/io.h>

void
board_lcd_init(void)
{
	reset_release("lcdc_clk");
	clk_enable("lcdc_clk");

	io_mux("lcdd2");
	io_mux("lcdd3");
	io_mux("lcdd4");
	io_mux("lcdd5");
	io_mux("lcdd6");
	io_mux("lcdd7");
	io_mux("lcdd10");
	io_mux("lcdd11");
	io_mux("lcdd12");
	io_mux("lcdd13");
	io_mux("lcdd14");
	io_mux("lcdd15");
	io_mux("lcdd18");
	io_mux("lcdd19");
	io_mux("lcdd20");
	io_mux("lcdd21");
	io_mux("lcdd22");
	io_mux("lcdd23");
	io_mux("lpclk");
	io_mux("lcdgp0");
	io_mux("lcdgp1");
	io_mux("lcdgp2");
}

static void
dvf101_rocktech_init(void)
{
}

static const struct dvf101_lcdc_panel dvf101_rocktech =
{
	.name = "rocktech",
	.xres = 800,
	.yres = 480,
	.bits_per_pixel = LCD_COLOR16,
	.clock_rate = 30000000,
	.init_fn = dvf101_rocktech_init,
	.init_seq = {
		/* Display panel */
		{ LCDC_REG_DISPIR,   0x0001 },	/* 24bits TFT-LCD */
		{ LCDC_REG_PANCSR,   0x0006 },	/* RGB order. Data is sampled on falling-edge of clk */

		/* Vertical Timing register */
		{ LCDC_REG_VSTR,          0 },
		{ LCDC_REG_VFTR,         23 },
		{ LCDC_REG_VETR,         22 },

		/* Horizontal Timing register*/
		{ LCDC_REG_HSTR,          1 },
		{ LCDC_REG_HFTR,         45 },
		{ LCDC_REG_HETR,        209 },

		{ LCDC_REG_YCLPCR,   0xff00 },
		{ LCDC_REG_CCLPCR,   0xff00 },

		{ LCDC_REG_ISTAR4,   0x4009 },

		{ LCDC_REG_GP3CNTR,  0x0001 }, /* GP3 set high (RESET) */

		{ LCDC_SEQ_END,      0x0000 }
	},
};

const struct dvf101_lcdc_panel *dvf101_panels[] = {
	&dvf101_rocktech,
	NULL,
};
