/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/clock.h>
#include <asm/arch/pads.h>
#include <asm/arch/hardware.h>
#include <asm/arch/serial.h>

DECLARE_GLOBAL_DATA_PTR;

static char *uart_name[] =
{ "uart1", "uart2" };
static char *mux_tx_name[] =
{ "u1tx", "u2tx" };
static char *mux_rx_name[] =
{ "u1rx", "u2rx" };

static void uart_init(int index)
{
	reset_release(uart_name[index]);
	clk_enable(uart_name[index]);

	io_mux(mux_tx_name[index]);
	io_mux(mux_rx_name[index]);
}

void board_serial_init(void)
{
#ifdef CONFIG_SERIAL_MULTI
	uart_init(0);
	uart_init(1);
#else
	int uart = get_uart_config();

	uart_init(uart);
#endif
}

void dvf99_serial_late_init(void)
{
#ifndef CONFIG_SERIAL_MULTI
	if (get_uart_config() == 0)
		setenv("console", "console=ttyS0");
	else
		setenv("console", "console=ttyS1");
#endif
}
