/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <lcd.h>
#include <spi.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/lcd.h>
#include <asm/arch/clock.h>
#include <asm/arch/pads.h>
#include <asm/arch/hardware.h>

void
board_lcd_init(void)
{
	reset_release("lcdc");
	clk_enable("lcdc");

	gpio_disable(DGPIO(6));  /* LCDD0 */
	gpio_disable(DGPIO(1));  /* LCDD1 */
	gpio_disable(DGPIO(2));  /* LCDD8 */
	gpio_disable(DGPIO(3));  /* LCDD9 */
	gpio_disable(DGPIO(4));  /* LCDD16 */
	gpio_disable(DGPIO(5));  /* LCDD17 */

	gpio_disable(CGPIO(0));  /* LCDD2 */
	gpio_disable(CGPIO(1));  /* LCDD3 */
	gpio_disable(CGPIO(2));  /* LCDD4 */
	gpio_disable(CGPIO(3));  /* LCDD5 */
	gpio_disable(CGPIO(4));  /* LCDD6 */
	gpio_disable(CGPIO(5));  /* LCDD7 */
	gpio_disable(CGPIO(6));  /* LCDD10 */
	gpio_disable(CGPIO(7));  /* LCDD11 */
	gpio_disable(CGPIO(8));  /* LCDD12 */
	gpio_disable(CGPIO(9));  /* LCDD13 */
	gpio_disable(CGPIO(10)); /* LCDD14 */
	gpio_disable(CGPIO(11)); /* LCDD15 */
	gpio_disable(CGPIO(12)); /* LCDD18 */
	gpio_disable(CGPIO(13)); /* LCDD19 */
	gpio_disable(CGPIO(14)); /* LCDD20 */
	gpio_disable(CGPIO(15)); /* LCDD21 */
	gpio_disable(CGPIO(16)); /* LCDD22 */
	gpio_disable(CGPIO(17)); /* LCDD23 */
	gpio_disable(DGPIO(7));  /* LPCLK */
	gpio_disable(CGPIO(19)); /* LCDGP0 */
	gpio_disable(CGPIO(20)); /* LCDGP1 */
	gpio_disable(CGPIO(21)); /* LCDGP2 */
	//gpio_disable(CGPIO(22)); /* LCDGP3 */
	//gpio_disable(CGPIO(23)); /* LCDGP4 */
	//gpio_disable(CGPIO(24)); /* LCDGP5 */
	//gpio_disable(CGPIO(25)); /* LCDGP6 */
	//gpio_disable(CGPIO(26)); /* LCDGP7 */
	//gpio_disable(CGPIO(27)); /* LCDGP8 */

	pads_enable("lcdc");
	pads_enable("lcdgp0");
	pads_enable("lcdgp1");
	pads_enable("lcdgp2");
	//pads_enable("lcdgp3");
	//pads_enable("lcdgp4");
	//pads_enable("lcdgp5");
	//pads_enable("lcdgp6");
	//pads_enable("lcdgp7");
	//pads_enable("lcdgp8");
}

static void
dvf99_rocktech_init(void)
{
	
}

static const struct dvf99_lcdc_panel dvf99_rocktech =
{
	.name = "rocktech",
	.xres = 800,
	.yres = 480,
	.bits_per_pixel = LCD_COLOR16,
	.clock_rate = 30000000,
	.init_fn = dvf99_rocktech_init,
	.init_seq = {
		/* Display panel */
		{ LCDC_REG_DISPIR,   0x0001 },	/* 24bits TFT-LCD */
		{ LCDC_REG_PANCSR,   0x0006 },	/* RGB order. Data is sampled on falling-edge of clk */

		/* Vertical Timing register */
		{ LCDC_REG_VSTR,          0 },
		{ LCDC_REG_VFTR,         23 },
		{ LCDC_REG_VETR,         22 },

		/* Horizontal Timing register*/
		{ LCDC_REG_HSTR,          1 },
		{ LCDC_REG_HFTR,         45 },
		{ LCDC_REG_HETR,        209 },

		{ LCDC_REG_YCLPCR,   0xff00 },
		{ LCDC_REG_CCLPCR,   0xff00 },

		{ LCDC_REG_ISTAR4,   0x4009 },

		{ LCDC_REG_GP3CNTR,  0x0001 }, /* GP3 set high (RESET) */

		{ LCDC_SEQ_END,      0x0000 }
	},
};

const struct dvf99_lcdc_panel *dvf99_panels[] = {
	&dvf99_rocktech,
	NULL,
};
