/*
 * (C) Copyright 2013 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/clock.h>
#include <asm/arch/pads.h>
#include <asm/arch/hardware.h>
#include <asm/arch/qspi.h>

void board_qspi_init(void)
{
	reset_release("qspi");

	gpio_pull_ctrl(AGPIO(7),  0, 0); /* CLK */
	gpio_pull_ctrl(AGPIO(8),  0, 0); /* D0 */
	gpio_pull_ctrl(AGPIO(9),  0, 0); /* D1 */
	gpio_pull_ctrl(AGPIO(10), 0, 0); /* D2 */
	gpio_pull_ctrl(AGPIO(11), 0, 0); /* D3 */
	gpio_disable(AGPIO(7));  /* CLK */
	gpio_disable(AGPIO(8));  /* D0 */
	gpio_disable(AGPIO(9));  /* D1 */
	gpio_disable(AGPIO(10)); /* D2 */
	gpio_disable(AGPIO(11)); /* D3 */
	gpio_disable(AGPIO(12)); /* CS0 */
	gpio_disable(AGPIO(13)); /* CS1 */

	pads_disable("fc");
	pads_enable("qspi");

	qspi_init();
}
