/*
 * (C) Copyright 2015 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/pads.h>
#include <asm/arch/hardware.h>
#include <asm/arch/dvf9a.h>
#include <asm/arch/rf_spif.h>

void board_rf_spif_init(void)
{
#if CONFIG_SDMMC_LOC_VAL == 1
#error "SDMMC location for data pins must be configured to 0 for SPIF interface"
#endif
	gpio_disable(BGPIO(27));
	gpio_disable(BGPIO(31)); /* ? */
	gpio_disable(BGPIO(11)); /* syncport */
	gpio_disable(DGPIO(25)); /* tr_data */
	gpio_disable(DGPIO(24)); /* radio_en */
	gpio_disable(DGPIO(17)); /* slot_ctrl */
	gpio_disable(DGPIO(16)); /* sen */
	gpio_disable(DGPIO(15)); /* sdata_in */
	gpio_disable(DGPIO(13)); /* sclk */
	gpio_disable(DGPIO(12)); /* sdata_out */
}
