/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/clock.h>
#include <asm/arch/pads.h>
#include <asm/arch/hardware.h>
#include <asm/arch/usb.h>

void
board_usb_init(void)
{
	clk_enable_usb1();

	/* disable USB power protection */
	gpio_direction_output(DGPIO(31), 1);

	/* activate DRV_VBUS pad */
	pads_enable("usb_drv_vbus");
	gpio_disable(DGPIO(26));
}

#ifdef CONFIG_USBD_DFU
int dfu_enter_dfu_mode(void);

int do_dfu(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	dfu_enter_dfu_mode();

	return 0;
}

U_BOOT_CMD(dfu, 2, 0, do_dfu,
		"dfu - Enter DFU mode.\n",
		""
	  );
#endif
