/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <config.h>
#include <asm/io.h>
#include <asm/arch/ccu.h>
#include <asm/arch/clock.h>
#include <asm/arch/usb.h>
#include <asm/arch/i2c.h>
#include <asm/arch/spi.h>
#include <asm/arch/tdm.h>
#include <asm/arch/apu.h>
#include <asm/arch/serial.h>
#include <asm/arch/hardware.h>
#include <asm/arch/keypad.h>
#include <asm/arch/qspi.h>
#include <asm/arch/upgrade.h>

DECLARE_GLOBAL_DATA_PTR;

int board_early_init_f(void)
{
	board_serial_init();
	board_apu_init();

	return 0;
}

int checkboard(void)
{
	puts("BOARD:" CONFIG_IDENT_STRING "\n");

	return 0;
}

int board_init(void)
{
	ccu_init();

	icache_enable();

	gd->bd->bi_boot_params = gd->bd->bi_dram[0].start + 0x100;

	board_qspi_init();
	board_spi_init();
	board_i2c_init();
	board_keypad_init();
	board_usb_init();
	board_tdm_init();

	return 0;
}

int board_late_init(void)
{
	dvf99_software_upgrade();
	dvf99_keypad_late_init();
	dvf99_serial_late_init();

	return 0;
}
