/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>

/* disable, input, pull-down */
static void
init_gpio(int gpio)
{
	gpio_disable(gpio);
	gpio_direction_input(gpio);
	gpio_pull_ctrl(gpio, 1, 0);
}

void
board_gpio_init(void)
{
	int i;

	for (i = 0; i <= 31; i++) {
		init_gpio(AGPIO(i));
		init_gpio(BGPIO(i));
		init_gpio(CGPIO(i));
		init_gpio(DGPIO(i));
		init_gpio(EGPIO(i));
	}

	gpio_direction_output(BGPIO(17), 0); /* KEY_LED */
	gpio_enable(BGPIO(17));
	gpio_direction_output(BGPIO(18), 0); /* LCD_BL */
	gpio_enable(BGPIO(18));
	gpio_direction_output(BGPIO(20), 0); /* SYS_PWR_CON */
	gpio_enable(BGPIO(20));
	gpio_direction_input(DGPIO(24)); /* ENDKEY_INTN (EXTINT9) */
	gpio_enable(DGPIO(24));
	gpio_direction_input(DGPIO(25)); /* CHG_DET (EXTINT10) */
	gpio_enable(DGPIO(24));
	gpio_direction_output(DGPIO(15), 1); /* CSEL_L */
	gpio_enable(DGPIO(15));
	gpio_direction_output(DGPIO(16), 1); /* WIFI_RSTN */
	gpio_enable(DGPIO(16));
	gpio_direction_output(DGPIO(17), 1); /* LCD_RSTN */
	gpio_enable(DGPIO(17));
}
