/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/hardware.h>
#include <asm/arch/keypad.h>

static void
dvf99_keypad_setup_row(int gpio)
{
	gpio_disable(gpio);
	gpio_pull_ctrl(gpio, 1, 1); // 0
}

static void
dvf99_keypad_setup_col(int gpio)
{
	gpio_disable(gpio);
	gpio_pull_ctrl(gpio, 1, 1);
}

void
board_keypad_init(void)
{
	dvf99_keypad_setup_row(EGPIO(18)); /* KROW0 */
	dvf99_keypad_setup_row(EGPIO(19)); /* KROW1 */
	dvf99_keypad_setup_row(EGPIO(20)); /* KROW2 */
	dvf99_keypad_setup_row(EGPIO(21)); /* KROW3 */
	dvf99_keypad_setup_row(EGPIO(22)); /* KROW4 */
	//dvf99_keypad_setup_row(EGPIO(29)); /* KROW5 */
	//dvf99_keypad_setup_row(EGPIO(30)); /* KROW6 */

	dvf99_keypad_setup_col(EGPIO(23)); /* KCOL0 */
	dvf99_keypad_setup_col(EGPIO(24)); /* KCOL1 */
	dvf99_keypad_setup_col(EGPIO(25)); /* KCOL2 */
	dvf99_keypad_setup_col(EGPIO(26)); /* KCOL3 */
	dvf99_keypad_setup_col(EGPIO(27)); /* KCOL4 */
	dvf99_keypad_setup_col(EGPIO(28)); /* KCOL5 */

	dvf99_keypad_init(5, 6);
}
