/*
 * (C) Copyright 2012 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <linux/mtd/nand.h>
#include <dmw96_nfc.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/clock.h>
#include <asm/arch/io.h>
#include <asm/arch/hardware.h>

#define NFLD_DRIVE_STRENGTH 0

static struct dmw96_nfc_dev nfc_dev = {
	.num = 0,
	.cs = 0,
	.readysel = 0,
};

int board_nand_init(struct nand_chip *nand)
{
	reset_release("nfc_clk");
	clk_enable("nfc_clk");

	/* NFC data (0-7) */
	io_mux("nflale");
	io_mux("nflcle");
	io_mux("nflcs0");
	io_mux("nfld0");
	io_mux("nfld1");
	io_mux("nfld2");
	io_mux("nfld3");
	io_mux("nfld4");
	io_mux("nfld5");
	io_mux("nfld6");
	io_mux("nfld7");
	io_mux("nflrd");
	io_mux("nflready1");
	io_mux("nflwr");

	/* Added by Grandstream */
	io_drive_strength("agpio0", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio1", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio2", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio3", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio4", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio5", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio6", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio7", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio8", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio9", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio10", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio11", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio12", NFLD_DRIVE_STRENGTH);
	io_drive_strength("agpio13", NFLD_DRIVE_STRENGTH);

	dmw96_nfc_init(&nfc_dev);

	/* MT29F2G08ABAFAWP, 256MB, ONFI compatible, 8-bit ECC */

	return 0;
}
