/*
 * (C) Copyright 2015 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/io.h>
#include <asm/arch/clock.h>
#include <asm/arch/hardware.h>
#include <asm/arch/serial.h>

DECLARE_GLOBAL_DATA_PTR;

static char *uart_name[] = {
	"uart1_clk", "uart2_clk", "uart3_clk", "uart4_clk"
};

static char *uart_tx_pin[] = { "u1tx", "u2tx", "u3tx", "u4tx" };
static char *uart_rx_pin[] = { "u1rx", "u2rx", "u3rx", "u4rx" };

static char *uart_cts_pin[] = { "u1cts" };
static char *uart_rts_pin[] = { "u1rts" };

static void uart_init(int index)
{
	reset_release(uart_name[index]);
	clk_enable(uart_name[index]);

	io_mux(uart_tx_pin[index]);
	io_mux(uart_rx_pin[index]);

	if (index == 0) {
		io_mux(uart_cts_pin[index]);
		io_mux(uart_rts_pin[index]);
	}
}

void board_serial_init(void)
{
#ifdef CONFIG_SERIAL_MULTI
	uart_init(0);
	uart_init(1);
	uart_init(2);
	uart_init(3);
#else
	int uart = get_uart_config();

	uart_init(uart);
#endif
}

void dvf_serial_late_init(void)
{
	int uart = get_uart_config();
	char tmp[14];

	if (uart >= 0 && uart < 4) {
		sprintf(tmp, "console=ttyS%d", uart);
		setenv("console", tmp);
	}
}
