/*
 * (C) Copyright 2013 DSP Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <asm/io.h>
#include <asm/arch/gpio.h>
#include <asm/arch/clock.h>
#include <asm/arch/hardware.h>
#include <asm/arch/tdm.h>

void board_tdm_init(void)
{
	int ret;

	io_mux("t2sclk");
	io_mux("f2sync");
	io_mux("d2tx");
	io_mux("d2rx");
	reset_release("tdm2_clk");

	ret = clk_set_rate("tdm2_clk", 8192000000);
	if (ret) {
		printf("error: cannot set eth chip clock rate to %lu\n",
			    8192000000);
		return ret;
	}

	clk_enable("tdm2_clk");
}
