/*
 * CSS load
 */
#include <common.h>
#include <command.h>

int css_load(const void *css, size_t size);

int do_css (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    char *endp;
	u32 addr;
	u32 size = 0;

    if (argc < 4)
        return CMD_RET_USAGE;

    // nothing accept load yet
    if (strcmp(argv[1], "load") != 0)
        return CMD_RET_USAGE;

	addr = simple_strtoul(argv[2], &endp, 16);
	if (endp == argv[2])
		return CMD_RET_USAGE;

	size = simple_strtoul(argv[3], &endp, 16);
	if (endp == argv[3])
		return CMD_RET_USAGE;

    if (css_load(addr, size) < 0)
        return CMD_RET_FAILURE;

    return CMD_RET_SUCCESS; 
}

/***************************************************/

U_BOOT_CMD(
	css,	4,	0,	do_css,
	"load <addr> <size>",
	"load: load css"
);
