#ifndef __CONFIG_EVB9918_NAND_H
#define __CONFIG_EVB9918_NAND_H

#define CONFIG_IDENT_STRING " evb9918-nand"

/*
 * Device drivers & peripherals:
 */
#define CONFIG_NAND
#define CONFIG_NETWORKING
#define CONFIG_I2C
#define CONFIG_DSPG_SPI
#define CONFIG_KEYPAD
#define CONFIG_TDM
#define CONFIG_APU

/*
 * Configure which UART to use for stdio
 * 0: choose UART1 or UART2 according to straps
 * 1: UART1
 * 2: UART2
 */
#define CONFIG_USE_UART		0

/* Only relevant when using UART2 */
#define CONFIG_UART2_LOC_VAL	0

#ifdef CONFIG_NETWORKING
    /* MII interface will be used by default */
    /* Enable one of the below in order to override (but keep CONFIG_MII above defined!) */
    /* #define CONFIG_SLVMII */
    #define CONFIG_RMII
    /* #define CONFIG_SLVRMII */
    /* #define CONFIG_RGMII */

    /* Atheros switch configuration */
    #define CONFIG_QCA833X_SWITCH
    #define CONFIG_MDC_MDIO_OPERATION
    #define CONFIG_MAIN_CLK_OUT
    #define CONFIG_RMII_CLK_OFF_CHIP

    #define CONFIG_ETH_RESET_GPIO EGPIO(10)
#endif

#define PHYS_SDRAM_1			0xC8000000
#define CONFIG_SYS_TEXT_BASE		0xC8400000
#define CONFIG_SYS_LOAD_ADDR		0xC8800000
#define CONFIG_SYS_DEVTREE_OFFSET	"0xC8C00000"
#define CONFIG_SYS_DEVICETREE		"dvf9918-evb.dtb"

#include <configs/dvf99.h>

#endif
