/*
 * include/dmw96_nfc.h
 *
 * Driver for the NAND flash controller on DMW96 chips.
 * Supports DMA and PIO transfers and different hardware ECC modes.
 *
 * Copyright (C) 2010 - 2012 DSP Group Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */
#ifndef __INCLUDE_DMW96_NFC_H
#define __INCLUDE_DMW96_NFC_H

struct dmw96_nfc_dev {
	int num;
	int cs;
	int readysel;
};

int dmw96_nfc_init(struct dmw96_nfc_dev *dev);

#endif
